; wallx v2.55 - ejn (blueznl)
; pb5.73LTS
; bluez@xs4all.nl
;
; - wallpaper loader & mini launcher
;
#program_version = "v2.55 'Newfangled' - save "+#codecaddy_save_nr+" build "+#codecaddy_build_nr
#program_copyright = "c2010..2021 EJN"
;
InitNetwork()
UseJPEGImageDecoder()
UseJPEGImageEncoder()
UsePNGImageDecoder()
UsePNGImageEncoder()
EnableExplicit
IncludeFile("..\x_lib\x_lib.pb")
Declare init()
Declare main()
x_init()
init()
main()
End
;
; this code is horrible!
; (it is the unholy child of a structural setup and endless piggybacking)
; do not read! it will destroy your mind and make you go blind! ... too late...
;

Procedure history()
  ;
  ; planned
  ;
  ; - dunno
  ;
  ; v2.54
  ;
  ;  - bugfix rearrange shortcuts
  ;  - drag shortcuts to rearrange shortcut panel
  ;  - changed default pairs to 10%
  ;
  ; v2.42
  ;
  ;  - remove / change shortcuts from within main window
  ;  - export icon images
  ;  - better handling of different file formats
  ;  - lots of other changes
  ;
  ; v2.25
  ;
  ; - create shortcuts to executables
  ; - uses wallx_url.ico and wallx_bat.ico if found when creating icons
  ;
  ; v2.23
  ;
  ; - renamed presets to shortcuts, removed separate wallpapers list and presets
  ; - combining different lists makes for a better user experience
  ; - better .lnk handling
  ; - more bugfixes (will there be any left for fangbeast to find?)
  ; - speedup drawing icons, less disk access
  ;
  ; v2.11
  ;
  ; - replaced dquotes with ~~ in presets file
  ; - replaced 'programfolder' with '~programfolder~', 'programpath' with '~programfolder~' etc. to be consistent everywhere
  ; - bugfixes
  ; - improved documentation
  ;
  ; v2.10
  ;
  ; - added drag and drop support
  ; - added drag and drop support
  ; - drop to window now recognizes .exe .bat .lnk .url .ico .jpg .bmp .png and paths
  ; - drop to window auto-processes entries as best as it can
  ; - icon information is now retrieved from .lnk and .url files (thx azjio)
  ; - some minor fixes related to updating gadgets
  ; - auto refresh and apply on adding preset entries
  ; - improved auto detection updated preset file
  ;
  ; v2.03
  ;
  ; - adding systray shortcuts
  ; - improved handling of updated stringfield gadgets
  ; - improved handling of refreshes (still poor, but ok)
  ; - code has turned to spaghetti!
  ;
  ; v1.94
  ;
  ; - improved help-file handling, use notepad if wallx.lst exists, littlehelp if it doesn't
  ; - better preset handling and easier editing
  ;
  ; v1.93
  ;
  ; - added command 'round'
  ; - reorganized gui a little
  ; - user can now create / remove presets by creating / editing wallx.cfg
  ;
  ; v1.91
  ;
  ; - window's always built when resident, but hidden when not in use
  ; - removed auto / try, everything is now immediately updated
  ; - added busy indicator
  ; - can now minimize
  ; - close moves to systray when resident, exits when not
  ; - exit button always exits
  ; - additional presets
  ; - miniature for markup relocated to center of primary screen
  ; - added 'fit' command
  ;
  ; v1.88
  ;
  ; - added span <filename>
  ;
  ; v1.87
  ;
  ; - regrouped some elements in the GUI
  ; - changed behavior on presets
  ; - 'background' And 'keep' are now defaults For all presets
  ; - changed 'expend' To 150, 'distort' To 15
  ; - bugfix pre10 in combination With presets
  ; - improved documentation
  ; - presets can now contain non-gui commands
  ; - gui switches To 'custom' preset when user changes an element (removed again in v2.11)
  ; - better detection of missing files
  ; - minor bugfix on 'keep'
  ; - no longer crashes on empty / invalid wallx.lst
  ; - replaced 'frame' command with 'markup'
  ;
  ; v1.85
  ;
  ; - improved handling of larger sets in wallx.lst
  ; - added option for pre-win10, win10 is now default
  ; - 'keep' is now set by default
  ; - default 'expand' is now set to 100
  ; - changed tiling mechanism for win10
  ; - bugfix aspect handling (improved resizing of odd formats on individual monitors)
  ; - some small bugfixes related to sets and missing files
  ;
  ; v1.81x
  ;
  ; - added support for .PNG and .BMP files
  ;
  ; v1.80
  ;
  ; - minor changes due to different handling of included data and localisation of labels
  ; - could sometimes miss one or more ip addresses, fixed
  ;
  ; v1.75x
  ;
  ; - fixed shown preset
  ; - fixed a bug with 'set'
  ; - improved path detection in generated commandlines
  ; - improved shortcut naming
  ; - led To indicate existence of autorun entry
  ; - updated documentation
  ; - modified behaviour when exiting gui
  ; - renamed 'resident' to 'background'
  ;
  ; v1.70x
  ;
  ; - a new gui
  ; - new 'invert' effect
  ; - full rewrite of internal command handling
  ; - added 'load image' without the 'load' command
  ; - so drag / drop of an image file on the wallx exe works now
  ; - desktop shortcut creation
  ; - create autorun option
  ; - expanded help text
  ; - more bugs! (thoug none that I am aware of :-))
  ;
  ; v1.63x
  ;
  ; - compiled with 4.61 beta 1
  ; - figured out some Windows 7 issues, updated docs
  ; - added a batch file and an image, updated help text
  ; - added 'tempfolder'
  ; - 'save' now sets 'keep' as well
  ; - added 'dotmark', 'darkmark', "wallmark"
  ; - added 'adminmark'
  ; - added 'blur' and 'darken'
  ; - added 'orange'
  ; - changed 'mark'
  ;
  ; v1.51x
  ;
  ; - improved (?) detection of ip changes
  ; - now handles no ethernet adapters (sony vaio without a pcmcia network adapter)
  ;
  ; v1.49x
  ;
  ; - forced screen update after 5 minute period without any messages (hibernation detection)
  ; - should (not fully explored yet) now be able to handle multiple ip adresses and show the last changed address
  ;
  ; v1.44x
  ;
  ; - bigfix, should no longer crash when using wallx.lst
  ; - using new version of x_lib
  ;
  ; v1.42x
  ;
  ; - changed path options, they were confusing
  ; - replaced 'current' with 'frompanel'
  ; - replaced 'random nearby' with 'random programfolder'
  ; - added 'random currentfolder'
  ;
  ; v1.40x
  ;
  ; - reversed all changes since 1.37x
  ; - added 'keep'
  ; - added 'current'
  ; - added 'pairs'
  ; - much improved documentation (help file)
  ;
  ; v1.36
  ;
  ; - added ~user~
  ; - added ~USER~
  ; - added ~HOST~
  ;
  ; v1.33
  ;
  ; - added 'renew'
  ; - added 'nouser'
  ;
  ; v1.32
  ;
  ; - bugfix 'silent'
  ; - fixed some typos
  ; - added batch file example for dropping image files
  ;
  ; v1.30
  ;
  ; - fixed a bug in selecting entry from wallx.lst
  ; - adding 'wrap around' step to handle windows' stupid wallpaper wrap
  ; - added 'frame' command (good for screenshots and debugging)
  ;
  ; v1.28x
  ;
  ; - 'random' now allows a path 'nearby'
  ;
  ; v1.26x
  ;
  ; - 'big' now bases fontsize on monitor size
  ; - added alerts to report missing files and unrecognized commands
  ; - added 'silent' parameter to silence the new alerts ;-)
  ;
  ; v1.22x
  ;
  ; - new 'random' keyword to load random file(s) from folder
  ; - recognizes wallx.lst file
  ; - transparent mode for superimposed text
  ; - added distort and expand commands
  ; - added transparent command
  ;
  ; v1.18x
  ;
  ; - added support for individual per monitor settings
  ; - improved load command, autodetects multi monitor wallpapers and auto adjusts images
  ;
  ; v1.17
  ;
  ; - upgraded to pb4.40b7
  ; - added registry routine as I 'tiling' to handle multi monitor setup
  ; - changed screen change detection for multi monitor support
  ;
  ; v1.16
  ;
  ; - figured out issues with vista (64) and gave up on it...
  ; - added better support for windows 98
  ; - fixed background on multiple lines of text
  ; - denies background changes by other programs when running resident (might help in vista)
  ;
  ; v1.07
  ;
  ; - restructured command line processing
  ; - improved littlehelp() routine
  ; - added 'real' command line processing (to be included in future x_lib's)
  ; - added reading from a configuration file
  ; - text command now allows empty lines
  ; - real time monitoring enabled
  ; - little 'lazyhelp' viewer included
  ;
  ; v1.00
  ;
  ; - had to turn this into a real program, as it was getting a little unmanageable :-)
  ;
  ; v0.08x
  ;
  ; - ah, something that works!
  ;
EndProcedure

Procedure init()
  Protected x.s, p.i
  ;
  ; *** initialize gui, constants, variables, red default presets etc.
  ;
  ;
  ; *** gui elements
  ;
  Enumeration
    ;
    #w_main_nr
    #w_shortcutpanel_nr
    #g_systrayicon
    #g_shortcut_t
    #g_shortcut
    #g_panel
    ;
    ; wallpapers tab
    ;
    #g_wallpaperframe
    ;
    #g_wallpapername_t
    #g_wallpapername
    #g_wallpaper_t
    #g_wallpaper
    #g_wallpaper_file_t
    #g_wallpaper_file
    #g_wallpaper_browse
    #g_effect1_t
    #g_effect1_dots
    #g_effect1_fade
    #g_effect1_darken
    #g_effect1_drain
    #g_effect1_invert
    #g_effect1_blur
    #g_big_text_t
    #g_big_text
    #g_big_transparent
    #g_big_reverse
    #g_effect2_t
    #g_effect2_dots
    #g_effect2_fade
    #g_effect2_darken
    #g_effect2_drain
    #g_effect2_invert
    #g_effect2_blur
    #g_normal_text_t
    #g_normal_text
    #g_normal_transparent_t
    #g_normal_transparent
    #g_normal_reverse
    #g_effect3_t
    #g_effect3_dots
    #g_effect3_fade
    #g_effect3_darken
    #g_effect3_drain
    #g_effect3_invert
    #g_effect3_blur
    #g_effect4_t
    #g_effect4_round
    ;
    #g_timeandplace_t
    #g_distort_t
    #g_distort
    #g_expand_t
    #g_expand
    #g_renew_t
    #g_renew
    #g_nouser_t
    #g_nouser
    ;
    #g_system_t
    #g_keep
    #g_resident
    #g_pre10
    #g_markup
    ;
    #g_commandline_t
    #g_commandline
    ;
    ; shortcuts tab
    ;
    #g_shortcutframe
    ;
    #g_shortcutname_t
    #g_shortcutname
    #g_executable_t
    #g_executable_name
    #g_executable_browse
    #g_parameters_t
    #g_parameters
    #g_path_t
    #g_path_name
    #g_path_browse
    #g_icon_t
    #g_icon_name
    #g_icon_browse
    ;
    #g_icon_image_t
    #g_icon_image
    #g_shortcutcommand_t
    #g_shortcutcommand
    ;
    #g_exportframe
    ;
    #g_exportpath_t
    #g_exportpath_name
    #g_exportpath_browse
    #g_exportsize_t
    #g_exportsize
    ;
    ; bottom buttons
    ;
    #g_autorun_led
    #g_autorun_set
    #g_autorun_clear
    #g_desktopshortcut
    #g_copy
    ;
    #g_editbatch
    #g_runprogram
    ;
    #g_busy_led
    #g_busy_led_t
    #g_refresh
    #g_addshortcut
    #g_removeshortcut
    #g_replaceshortcut
    #g_editshortcuts
    #g_help
    #g_exit
    #g_exporticonimage
    ;
    ; other
    ;
    #g_shortcutpanel
    ;
  EndEnumeration
  ;
  ; *** combobox dropdown lists
  ;
  Enumeration
    #default_shortcut_autorun
    #default_shortcut_separator
  EndEnumeration
  ;
  Enumeration
    #g_wallpaper__randomcolour
    #g_wallpaper__loadfile
    #g_wallpaper__spanfile
    #g_wallpaper__fitfile
    #g_wallpaper__red
    #g_wallpaper__green
    #g_wallpaper__blue
    #g_wallpaper__yellow
    #g_wallpaper__cyan
    #g_wallpaper__lime
    #g_wallpaper__orange
    #g_wallpaper__pink
    #g_wallpaper__black
    #g_wallpaper__grey
    #g_wallpaper__white
    #g_wallpaper__traffic
    #g_wallpaper__base
    #g_wallpaper__frompath
    #g_wallpaper__programfolder
  EndEnumeration
  ;
  Global w_main_h.i
  Global w_shortcutpanel_h.i
  Global shortcutpanel_width.i, shortcutpanel_height.i
  ;
  ; *** images
  ;
  Enumeration 100
    ;
    #i_temp1
    #i_temp2
    #i_temp3
    #i_temp4
    #i_temp5
    ;
    #i_wallpaper_output
    #i_wallpaper_input
    #i_iconbutton
    ;
    #i_wallnut
    #i_empty
    #i_led_white
    #i_led_green
    #i_led_red
    #i_eyes_2
    #i_eyes_3
    #i_windows
    #i_windows_grey
    #i_copy
    #i_help
    #i_exit
    #i_disk
    #i_shortcut
    #i_bullets
    #i_plus
    #i_minus
    #i_equal
    #i_play_green
    #i_missing
    #i_notepad
    #i_web
    #i_batch
    ;
    #i_shortcutpanel
  EndEnumeration
  ;
  DataSection
    ;
    i_wallnut:
    IncludeBinary("icons\walnut.ico")
    i_empty:
    IncludeBinary("icons\empty.ico")
    i_led_white:
    IncludeBinary("icons\led_white.ico")
    i_led_green:
    IncludeBinary("icons\led_green.ico")
    i_led_red:
    IncludeBinary("icons\led_red.ico")
    i_eyes_2:
    IncludeBinary("icons\eyes_2.ico")
    i_eyes_3:
    IncludeBinary("icons\eyes_3.ico")
    i_copy:
    IncludeBinary("icons\copy.ico")
    i_help:
    IncludeBinary("icons\help.ico")
    i_shortcut:
    IncludeBinary("icons\shortcut.ico")
    i_windows_xp:
    IncludeBinary("icons\windows_xp.ico")
    i_windows_grey:
    IncludeBinary("icons\windows_grey.ico")
    i_bullets:
    IncludeBinary("icons\bullets.ico")
    i_exit:
    IncludeBinary("icons\exit.ico")
    i_disk:
    IncludeBinary("icons\disk_1.ico")
    i_plus:
    IncludeBinary("icons\plus_2.ico")
    i_minus:
    IncludeBinary("icons\minus_2.ico")
    i_equal:
    IncludeBinary("icons\equal_2.ico")
    i_play_green:
    IncludeBinary("icons\play_green.ico")
    i_missing:
    IncludeBinary("icons\missing.ico")
    i_notepad:
    IncludeBinary("icons\notebook_1.ico")
    i_web:
    IncludeBinary("icons\globe.ico")
    i_batch:
    IncludeBinary("icons\gears_1.ico")
    ;
  EndDataSection
  ;
  Global i_wallnut_h       = CatchImage(#i_wallnut,      ?i_wallnut)
  Global i_empty_h         = CatchImage(#i_empty,        ?i_empty)
  Global i_led_white_h     = CatchImage(#i_led_white,    ?i_led_white)
  Global i_led_green_h     = CatchImage(#i_led_green,    ?i_led_green)
  Global i_led_red_h       = CatchImage(#i_led_red,      ?i_led_red)
  Global i_eyes_2_h        = CatchImage(#i_eyes_2,       ?i_eyes_2)
  Global i_eyes_3_h        = CatchImage(#i_eyes_3,       ?i_eyes_3)
  Global i_copy_h          = CatchImage(#i_copy,         ?i_copy)
  Global i_help_h          = CatchImage(#i_help,         ?i_help)
  Global i_exit_h          = CatchImage(#i_exit,         ?i_exit)
  Global i_disk_h          = CatchImage(#i_disk,         ?i_disk)
  Global i_shortcut_h      = CatchImage(#i_shortcut,     ?i_shortcut)
  Global i_windows_h       = CatchImage(#i_windows,      ?i_windows_xp)
  Global i_windows_grey_h  = CatchImage(#i_windows_grey, ?i_windows_grey)
  Global i_bullets_h       = CatchImage(#i_bullets,      ?i_bullets)
  Global i_plus_h          = CatchImage(#i_plus,         ?i_plus)
  Global i_minus_h         = CatchImage(#i_minus,        ?i_minus)
  Global i_equal_h         = CatchImage(#i_equal,        ?i_equal)
  Global i_play_green_h    = CatchImage(#i_play_green,   ?i_play_green)
  Global i_missing_h       = CatchImage(#i_missing,      ?i_missing)
  Global i_notepad_h       = CatchImage(#i_notepad,      ?i_notepad)
  Global i_web_h           = CatchImage(#i_web,          ?i_web)
  Global i_batch_h         = CatchImage(#i_batch,        ?i_batch)
  ;
  ;
  ; *** libraries, dlls
  ;
  OpenLibrary(1,"shell32.dll")
  Global p_shextracticonsw.i = GetFunction(1,"SHExtractIconsW")
  ;
  ;
  ; *** .ico file
  ;
  Structure ICON_DIR
    idReserved.u;   // Reserved (must be 0)
    idType.u    ;       // Resource Type (1 for icons)
    idCount.u   ;      // How many images?
  EndStructure
  ;
  Structure ICON_DIR_ENTRY
    bWidth.a;          // Width, in pixels, of the image
    bHeight.a;         // Height, in pixels, of the image
    bColorCount.a;     // Number of colors in image (0 if >=8bpp)
    bReserved.a  ;     // Reserved ( must be 0)
    wPlanes.u    ;     // Color Planes
    wBitCount.u  ;     // Bits per pixel
    dwBytesInRes.l;    // How many bytes in this resource?
    dwImageOffset.l;   // Where in the file is this image?
  EndStructure
  ;
  ;
  ; *** variables / command line parameters
  ;
  Global helptext.s                                              ; text to show for help function
  Global wall_filename.s = GetTemporaryDirectory()+"wallx.bmp"   ; temporary filename used for creating the background
  Global fontname.s = "Arial"                                    ; default font (name)
  Global fontsize.i = 64                                         ; default font (size)
  Global fontcolor = $FFFFFF                                     ; default font (color)
  Global stayresident.i = #False                                 ; stay alive and monitor IP or screen changes
  Global keep.i = #False                                         ; set cpanel, do not remove temp
  Global pre10.i = #False                                        ; use pre10 method for multi monitor wallpapers on platforms older than win10
  Global markup.i = #False                                       ; mark boundaries of monitors on wallpaper, add loaded files etc. (primarily for debugging purposes)
  Global pairs.i = 10                                            ; default percentage for using wallx.lst entries
  Global killmessage.s = "wallx - terminate"                     ; message used to kill wallx instances
  Global killmessage_nr.i = RegisterWindowMessage_(@killmessage) ; registered message number for the kill message
  ;
  Global desktops_n.i                                            ; number of desktops (monitors)
  Global wallpaper_x.i, wallpaper_y.i                            ; wallpaper origion (top leftmost screen corner)
  Global wallpaper_width.i, wallpaper_height.i                   ; total desktops width and height
  Global wallpaper_aspect.f                                      ; wallpaper (total desktop) ratio
  Global lastfile_width.i, lastfile_height.i                     ; last loaded wallpaper dimensions
  Global lastfile_aspect.f                                       ; last loaded wallpaper ratio
  Global lastfile_filename.s                                     ; last loaded wallpaper name
  Global lastfile_action.s                                       ; action on last loaded file
  Global aspect_distort.i = 15                                   ; image may be distorted up to 15% (half that for single screen images)
  Global multi_expand.i = 150                                    ; image may be expanded up to for multi monitor setups 150%
  Global transparent.i = #False                                  ; draw text in transparent mode (default off)
  Global silent.i = #False                                       ; alert on missing files and wrong commands (default on)
  Global renew.i = 0                                             ; refresh wallpaper after n seconds, 0 is no refresh (default 0)
  Global renew_counter.i = 0                                     ; number of ticks since last refresh
  Global freeze_counter.i = 0                                    ; number of ticks since previous event
  Global nouser.i = 120                                          ; only refresh if there is no user activity (default 2 minutes)
  ;
  Global Dim ipaddress.i(20)                                     ; array with all ip adresses
  Global ipaddress_n.i                                           ; nr of entries
  Global old_ipaddress_n.i                                       ; old nr of entries
  Global ipaddress_now.i                                         ; current ip adress (best guess :-))
  ;
  ;
  ; *** desktop / area information used to build the background map
  ;
  Structure desktop
    x.i                                                          ; x coordinate of desktop
    y.i                                                          ; y coordinate of desktop
    width.i                                                      ; width of desktop
    height.i                                                     ; height of desktop
    depth.i                                                      ; colour depth
  EndStructure
  ;
  ;  Structure LASTINPUTINFO                                     ; structure for detection of user activity
  ;    cbSize.l
  ;    dwTime.l
  ;  EndStructure
  ;
  Global Dim desktop.desktop(10)                                 ; create an array for 10 screens, that should do it :-)
  Global Dim area_filename.s(10)                                 ; store names of assigned wallpapers per area (for the markup command, bit of a hack)
  Global area_selected.i = -1                                    ; selected area aka desktop aka monitor (-1 means all)
  Global area_n.i                                                ; desktop for which output is prepared (mostly used as a loop counter)
  Global area_first.i, area_last.i                               ; first and last desktop to draw on (simplifies per desktop vs. for all code)
  Global area_x.i, area_y.i                                      ; x,y of the area of the big generated wallpaper related to the specified monitor
  Global area_width.i, area_height.i                             ; width / height
  Global area_aspect.f                                           ; aspect ratio
  ;
  DataSection
    helptext:
    IncludeBinary("wallx.txt")
    Data.b 0, 0
  EndDataSection
  Global p_helptext = ?helptext
  ;
  ;
  ; *** event handling
  ;
  Global event.i, event_window.i, event_gadget.i, event_menu.i, event_type.i   ; variables for event handling
  ;
  ;
  ; *** shortcuts
  ;
  Enumeration
    #shortcut_separator
    #shortcut_wallpaper
    #shortcut_shortcut
  EndEnumeration
  ;
  DataSection
    default_shortcuts:
    IncludeBinary "wallx.cfg"
    Data.b 0,0
  EndDataSection
  Global p_default_shortcuts = ?default_shortcuts
  Global shortcuts.s
  ;
  Structure shortcut
    type.i                                                       ; 0 = separator, 1 = wallpaper, 2 = shortcut
    name.s
    executable.s
    parameters.s
    path.s
    icon.s
    x.i
    y.i
    w.i
    h.i
    image_high.i
    image_low.i
  EndStructure
  ;
  Global NewList shortcut.shortcut()
  Global NewList comment.s()
  ;
  ;
  ; *** other
  ;
  Global commandline.s                                                ; (generated or retrieved) commandline
  Global command_n.i                                                  ; number of commands in the commandline string
  Global gui.i                                                        ; flag that indicates a gui is used instead of a hidden window
  Global command_error.i                                              ; indicates a command or parameter was unrecognized
  Global exportpath.s = "'~programfolder~"                            ; path to export icons to
  Global exportsize.i = 128                                           ; default size of exported images
  Global configsize.i, configdate.i, configtimer.i                    ; used for autodection of changed config file
  Global configfile.s = GetPathPart(ProgramFilename())+"wallx.cfg"    ; configfile
  ;
EndProcedure

Procedure.s maketext(text.s)
  Protected n.i, x.s
  ;
  ; *** replaces placeholders with actual information
  ;
  ; replace eventual placeholders such as ~ip~
  ;
  text = ReplaceString(text,"~user~",GetEnvironmentVariable("USERNAME"))
  text = ReplaceString(text,"~ip~",IPString(ipaddress_now))
  text = ReplaceString(text,"~host~",Hostname())
  text = ReplaceString(text,"~timestamp~",FormatDate("%dd/%mm/%yy %hh:%ii:%ss",Date()))
  text = ReplaceString(text,"~desktop~",Str(area_n+1))
  text = ReplaceString(text,"~monitor~",Str(area_n+1))
  ;
  text = ReplaceString(text,"~USER~",UCase((GetEnvironmentVariable("USERNAME"))))
  text = ReplaceString(text,"~HOST~",UCase(Hostname()))
  ;
  If FindString(text,"~ipall~") > 0
    n = 0
    x = ""
    While n < ipaddress_n
      n = n+1
      x = x+IPString(ipaddress(n))+" "
    Wend
    text = ReplaceString(text,"~ipall~",Trim(x))
  EndIf
  
  ProcedureReturn text.s
  ;
EndProcedure

Procedure.i checkdesktops()
  Protected change.i, nn.i
  ;
  ; *** check for desktop changes
  ;
  ; retval: #true    - desktop has changed since last check
  ;         #false   - no change since last check
  ;
  ; get information on all desktops and report if there were changes
  ;
  wallpaper_x = 0
  wallpaper_y = 0
  wallpaper_width = 0
  wallpaper_height = 0
  ;
  change.i = #False
  If ExamineDesktops() <> desktops_n
    change = #True
    desktops_n = ExamineDesktops()
  EndIf
  ;
  wallpaper_x = 0
  wallpaper_y = 0
  wallpaper_width = 0
  wallpaper_height = 0
  ;
  nn = 0
  While nn < desktops_n
    If desktop(nn)\depth <> DesktopDepth(nn) Or desktop(nn)\x <> DesktopX(nn) Or desktop(nn)\y <> DesktopY(nn) Or desktop(nn)\width <> DesktopWidth(nn) Or desktop(nn)\height <> DesktopHeight(nn)
      desktop(nn)\x = DesktopX(nn)
      desktop(nn)\y = DesktopY(nn)
      desktop(nn)\width = DesktopWidth(nn)
      desktop(nn)\height = DesktopHeight(nn)
      desktop(nn)\depth = DesktopDepth(nn)
      change = #True
    EndIf
    ;
    wallpaper_x = x_min(wallpaper_x,desktop(nn)\x)
    wallpaper_y = x_min(wallpaper_y,desktop(nn)\y)
    wallpaper_width = x_max(wallpaper_width,desktop(nn)\x+desktop(nn)\width)
    wallpaper_height = x_max(wallpaper_height,desktop(nn)\y+desktop(nn)\height)
    ;
    nn = nn+1
  Wend
  ;
  wallpaper_width = wallpaper_width-wallpaper_x
  wallpaper_height = wallpaper_height-wallpaper_y
  ;
  ProcedureReturn change
EndProcedure

Procedure.i checkipadresses()
  Protected ipaddress_test.i, change.i
  ;
  ExamineIPAddresses()
  ipaddress_test = NextIPAddress()
  ipaddress_now = ipaddress_test
  ;
  ipaddress_n = 0
  While ipaddress_test <> 0 And ipaddress_n < 20
    ipaddress_n = ipaddress_n+1
    If ipaddress_test <> ipaddress(ipaddress_n)
      ipaddress(ipaddress_n) = ipaddress_test
      If ipaddress_test <> 0
        ipaddress_now = ipaddress_test
      EndIf
      change = #True
    EndIf
    If ipaddress_now = 0
      ipaddress_now = ipaddress_test
    EndIf
    ipaddress_test = NextIPAddress()
  Wend
  If ipaddress_n <> old_ipaddress_n
    old_ipaddress_n = ipaddress_n
    change = #True
  EndIf
  ;
  ProcedureReturn change
EndProcedure

Procedure getdesktopposition(n)
  ;
  ; *** get boundaries (position, size) of monitor to set output to
  ;
  ; ah... shades of the old purebasic usewhatever commands :-)
  ;
  ; there seems to be some inconsistensies inside windows regarding desktop wallpapers
  ; when dealing with multi monitor setups with different screen sizes , this should
  ; fix it
  ;
  If n < 0 Or n >= desktops_n
    n = 0
  EndIf
  If n = -1
    area_x = 0
    area_y = 0
    area_width = wallpaper_width
    area_height = wallpaper_height
  Else
    area_x = desktop(n)\x-wallpaper_x
    area_y = desktop(n)\y-wallpaper_y
    area_width = desktop(n)\width
    area_height = desktop(n)\height
  EndIf
  area_aspect = area_width / area_height
  ;
EndProcedure

Procedure.i saveicon(image_nr.i, file.s)
  Protected Width.i
  Protected Height.i
  Protected *Offset
  Protected *Buffer
  Protected BufferSize
  Protected *icon.ICON_DIR
  Protected *entry.ICON_DIR_ENTRY
  Protected Handle.i
  Protected Bytes.i
  Protected Result.i
  ;
  ; code by mijikai
  ;
  If IsImage(image_nr)
    Width = ImageWidth(image_nr)
    Height = ImageHeight(image_nr)
    If Width = Height
      ;
      ; note: icons are supposed to be square, and 16, 32, 48 or 128 pixels in size (but 64 and 96 seem to work fine)
      ;
      *Buffer = EncodeImage(Image_nr,#PB_ImagePlugin_PNG,#Null,32)
      If *Buffer
        BufferSize = MemorySize(*Buffer)
        *Offset = SizeOf(ICON_DIR) + SizeOf(ICON_DIR_ENTRY)
        *icon = AllocateMemory(*Offset + BufferSize)
        *icon\idType = 1
        *icon\idCount = 1
        *entry = *icon + SizeOf(ICON_DIR)
        *entry\bWidth = Width
        *entry\bHeight = Height
        *entry\wBitCount = 32
        *entry\dwBytesInRes = BufferSize
        *entry\dwImageOffset = *Offset
        CopyMemory(*Buffer,*icon + *Offset,BufferSize)
        Handle = CreateFile(#PB_Any,File)
        If Handle
          Bytes = MemorySize(*icon)
          Result = Bool(WriteData(Handle,*icon,Bytes) = Bytes)
          CloseFile(Handle)
          If Not Result
            DeleteFile(File)
          EndIf
        EndIf
        FreeMemory(*icon)
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure.i saveicon_2(hIcon, filename.s)
  ;
  ; *** save .ico file
  ;
  ; code by srod
  ;
  Protected result, iconinfo.ICONINFO, hbmMask, hbmColor
  Protected cbitmap.BITMAP, cwidth, cheight, cbitsperpixel, colorcount, colorplanes
  Protected mbitmap.BITMAP, mwidth, mheight, fIcon, xHotspot, yHotspot
  Protected file, imagebytecount, hdc, oldbitmap, mem, bytesinrow, temp
  Protected *bitmapinfo.BITMAPINFO
  ;
  ; Get information regarding the icon.
  ;
  If Not(GetIconInfo_(hIcon, iconinfo)) : ProcedureReturn 0 : EndIf ;Not a valid icon handle.
  fIcon=2-iconinfo\fIcon ;icon = 1, cursor = 2,
  If fIcon=2 ;Cursor.
    xHotspot=iconinfo\xHotspot
    yHotspot=iconinfo\yHotspot
  EndIf
  ;
  ; Allocate memory for a BITMAPINFO structure + a color table with 256 entries.
  ;
  *bitmapinfo = AllocateMemory(SizeOf(BITMAPINFO) + SizeOf(RGBQUAD)<<8)
  If *bitmapinfo = 0 : ProcedureReturn 0 :EndIf
  ;
  ; Get the mask (AND) bitmap, which, if the icon is B/W monochrome, contains the colour bitmap.
  ;
  hbmMask=iconinfo\hbmMask
  GetObject_(hbmMask, SizeOf(BITMAP),mbitmap)
  mwidth= mbitmap\bmWidth
  mheight= mbitmap\bmHeight
  ;
  ; Get the colour (XOR) bitmap.
  ;
  hbmColor=iconinfo\hbmColor
  If hbmColor
    GetObject_(hbmColor, SizeOf(BITMAP),cbitmap)
    cwidth= cbitmap\bmWidth
    cheight= cbitmap\bmHeight
    cbitsperpixel = cbitmap\bmBitsPixel
    If cbitsperpixel = 0 : cbitsperpixel = 1 : EndIf
    If cbitsperpixel < 8
      colorcount=Pow(2,cbitsperpixel) ;colorcount = 0 if 8 or more bpp.
    EndIf
    colorplanes=cbitmap\bmplanes
  Else
    ;
    ; Monochrome icon.
    ;
    cwidth= mwidth
    cheight= mheight/2
    cbitsperpixel = 1
    colorcount=2
    colorplanes=1
    mheight=cheight
  EndIf
  ;
  ; Ready To start creating the file.
  ;
  file = CreateFile(#PB_Any,filename)
  If file
    ;
    ;Write the data.
    ;word = 0
    ;
    WriteWord(file,0)
    ;
    ;word = 1 for icon, 2 for cursor.
    ;
    WriteWord(file,ficon) ;1 for icon, 2 for cursor.
    ;
    ;word = number of icons in file.
    ;
    WriteWord(file,1)  ;***CHANGE IF EXTENDING CODE TO MORE THAN ONE ICON***
    ;
    ;16 byte ICONDIRENTRY structure, one for each icon.
    ;
    WriteByte(file, cwidth)
    WriteByte(file, cheight)
    WriteByte(file, colorcount)
    WriteByte(file, 0) ;Reserved.
    If ficon=1 ;Icon.
      WriteWord(file, colorplanes) ;Should equal 1, -but just in case!
      WriteWord(file, cbitsperpixel)
    Else ;Cursor.
      WriteWord(file, xhotspot)
      WriteWord(file, yhotspot)
    EndIf
    WriteLong(file,0) ;TEMPORARY! WE NEED TO RETURN WHEN WE KNOW THE EXACT QUANTITY.
    ;
    ; Size of (InfoHeader + ANDbitmap + XORbitmap)
    ;
    WriteLong(file,Loc(file)+4)  ;FilePos, where InfoHeader starts
    ;
    ;Now the image data in the form BITMAPINFOHEADER (40 bytes) + colour map for the colour bitmap
    ;+ bits of colour bitmap + bits of mask bitmap. Gulp! One for each icon.
    ;40 byte BITMAPINFOHEADER structure.
    ;
    imagebytecount=SizeOf(BITMAPINFOHEADER)
    WriteLong(file, imagebytecount) ;Should be 40.
    WriteLong(file, cwidth)
    WriteLong(file, cheight+mheight) ;Combined heights of colour + mask images.
    WriteWord(file, colorplanes) ;Should equal 1, -but just in case!
    WriteWord(file, cbitsperpixel)
    WriteLong(file, 0) ;Compression.
    WriteLong(file, 0) ;Image size. Valid to set to zero if there's no compression.
    WriteLong(file, 0) ;Unused.
    WriteLong(file, 0) ;Unused.
    WriteLong(file, 0) ;Unused.
    WriteLong(file, 0) ;Unused.
    ;
    ;Colour map. Only applies for <= 8 bpp.
    ;
    hdc=CreateCompatibleDC_(0) ;Needed in order to get the colour table.
    If hbmColor = 0 ;Monochrome icon.
      WriteLong(file, #Black)
      WriteLong(file, #White)
      imagebytecount+SizeOf(rgbquad)*2
    ElseIf cbitsperpixel<=8 ;Includes 1 bit non-monochrome icons.
      ;
      ;Get colour table.
      ;
      temp=Pow(2,cbitsperpixel)
      bytesinrow = SizeOf(rgbquad)*temp
      mem=AllocateMemory(bytesinrow)
      oldbitmap=SelectObject_(hdc, hbmColor)
      GetDIBColorTable_(hdc, 0, temp, mem)
      WriteData(file, mem, bytesinrow) ;Write color table.
      FreeMemory(mem)
      SelectObject_(hdc, oldbitmap)
      imagebytecount+bytesinrow
    EndIf
    ;
    ;Now the colour image bits. We use GetDiBits_() for this.
    ;
    bytesinrow = (cwidth*cbitsperpixel+31)/32*4  ;Aligned to a 4-byte boundary.
    bytesinrow * cheight
    mem=AllocateMemory(bytesinrow)
    *bitmapinfo\bmiHeader\biSize=SizeOf(BITMAPINFOHEADER)
    *bitmapinfo\bmiHeader\biWidth=cwidth
    *bitmapinfo\bmiHeader\biPlanes=colorplanes
    *bitmapinfo\bmiHeader\biBitCount=cbitsperpixel
    If hbmColor
      *bitmapinfo\bmiHeader\biHeight=cheight
      GetDIBits_(hdc,hbmColor,0,cheight,mem,*bitmapinfo,#DIB_RGB_COLORS)
    Else ;Monochrome color image is the bottom half of the mask image.
      *bitmapinfo\bmiHeader\biHeight=2*cheight
      GetDIBits_(hdc,hbmMask,0,cheight,mem,*bitmapinfo,#DIB_RGB_COLORS)
    EndIf
    WriteData(file, mem, bytesinrow)
    FreeMemory(mem)
    imagebytecount+bytesinrow
    ;
    ;Now the mask image bits. We use GetDiBits_() for this.
    ;
    bytesinrow = (mwidth+31)/32*4  ;Aligned to a 4-byte boundary.
    bytesinrow * mheight
    mem=AllocateMemory(bytesinrow)
    *bitmapinfo\bmiHeader\biWidth=mwidth
    *bitmapinfo\bmiHeader\biPlanes=1
    *bitmapinfo\bmiHeader\biBitCount=1
    If hbmColor
      *bitmapinfo\bmiHeader\biHeight=mheight
      GetDIBits_(hdc,hbmMask,0,mheight,mem,*bitmapinfo,#DIB_RGB_COLORS)
    Else
      *bitmapinfo\bmiHeader\biHeight=2*mheight
      GetDIBits_(hdc,hbmMask,mheight,mheight,mem,*bitmapinfo,#DIB_RGB_COLORS)
    EndIf
    WriteData(file, mem, bytesinrow)
    FreeMemory(mem)
    imagebytecount+bytesinrow
    DeleteDC_(hdc)
    ;
    ;Finally, return to the field we missed out.
    ;
    FileSeek(file, 14)
    WriteLong(file, imagebytecount)
    CloseFile(file)
    result= 1 ;Signal everything is fine.
  Else
    result= 0
  EndIf
  DeleteObject_(hbmMask) ;These are copies created as a result of GetIconInfo_() and so require deleting.
  DeleteObject_(hbmColor)
  FreeMemory(*bitmapinfo)
  ProcedureReturn result
EndProcedure

Procedure loadfile(file.s)
  Protected image_aspect.f, cut_height.i, cut_width.i, cut_x.i, cut_y.i, retval.i
  ;
  ; *** load a wallpaper
  ;
  ; - if the aspect ratio differs too much the image is cropped
  ; - for single screen images only half the distortion of multi screen images is accepted
  ; - automatically detect and apply multi monitor images
  ;
  ; global aspect_distort.i defines the amount of distortion in %
  ; global multi_expend.i defines the amount of expension for multi monitor setups in %
  ;
  file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
  If LoadImage(#i_wallpaper_input,file) = 0
    ;
    lastfile_action = "no image"
    ;
    If silent
    Else
      MessageRequester("WallX "+#program_version,"Missing image file"+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok|#MB_ICONERROR)
    EndIf
    ;
  Else
    ;
    wallpaper_aspect = wallpaper_width / wallpaper_height
    image_aspect = ImageWidth(#i_wallpaper_input)/ImageHeight(#i_wallpaper_input)
    ;
    lastfile_width = ImageWidth(#i_wallpaper_input)
    lastfile_height = ImageHeight(#i_wallpaper_input)
    lastfile_aspect = lastfile_width / lastfile_height
    lastfile_filename = file.s
    ;
    If wallpaper_aspect*115 > image_aspect*(100-aspect_distort) And wallpaper_aspect*(100-aspect_distort)< image_aspect*115 And ImageWidth(#i_wallpaper_input)*100 > wallpaper_width*(100-multi_expand) And ImageHeight(#i_wallpaper_input)*100 > wallpaper_height*(100-multi_expand)
      ;
      ; aspect ratio is more or less matching the wallpaper aka combined desktops
      ; and we think there's enough detail so let's build it
      ;
      ; can we stretch it at once? (ie. allow a little distortion but no need to clip things)
      ;
      If wallpaper_aspect*100 > image_aspect*(100-aspect_distort) And wallpaper_aspect*(100-aspect_distort) < image_aspect*100
        ;
        ; aspect rations match sufficiently, stretch to cover all desktops
        ;
        lastfile_action = "multi > stretch+distort"
        ;
        StartDrawing(ImageOutput(#i_wallpaper_output))
          DrawImage(ImageID(#i_wallpaper_input),0,0,wallpaper_width,wallpaper_height)
        StopDrawing()
        ;
      Else
        ;
        ; aspect rations differ too much, crop the image a bit
        ;
        lastfile_action = "multi > crop"
        ;
        If wallpaper_aspect > image_aspect
          cut_width = ImageWidth(#i_wallpaper_input)
          cut_height = x_min( ImageHeight(#i_wallpaper_input) , ImageWidth(#i_wallpaper_input) / wallpaper_aspect * 100 / (100-aspect_distort) )
          cut_x = 0
          cut_y = (ImageHeight(#i_wallpaper_input)-cut_height)/2
        Else
          cut_height = ImageHeight(#i_wallpaper_input)
          cut_width = x_min( ImageWidth(#i_wallpaper_input) , ImageHeight(#i_wallpaper_input) * wallpaper_aspect * 100 / (100-aspect_distort) )
          cut_x = (ImageWidth(#i_wallpaper_input)-cut_width)/2
          cut_y = 0
        EndIf
        StartDrawing(ImageOutput(#i_wallpaper_input))
          GrabDrawingImage(#i_temp3,cut_x,cut_y,cut_width,cut_height)
        StopDrawing()
        StartDrawing(ImageOutput(#i_wallpaper_output))
          DrawImage(ImageID(#i_temp3),0,0,wallpaper_width,wallpaper_height)
        StopDrawing()
        FreeImage(#i_temp3)
        ;
      EndIf
      ;
    Else
      ;
      ; loaded image wasn't suitable for the multi monitor setup, so let's place it on all selected desktops
      ;
      For area_n = area_first To area_last
        getdesktopposition(area_n)
        area_filename(area_n) = file                                                                                     ; store name so it can be shown with the markup command
        ;
        If area_aspect*100 > image_aspect*(100-aspect_distort/2) And area_aspect*(100-aspect_distort/2) < image_aspect*100
          ;
          ; aspect rations match sufficiently, stretch to cover selected desktop
          ; note: distortion ratio accepted for single screens is half that of multi monitor setups
          ; (arbitrary decision, I admit :-))
          ;
          lastfile_action = "single > stretch+distort"
          ;
          StartDrawing(ImageOutput(#i_wallpaper_output))
            DrawImage(ImageID(#i_wallpaper_input),area_x,area_y,area_width,area_height)
          StopDrawing()
          ;
        Else
          ;
          ; aspect rations differ too much, crop the image
          ;
          lastfile_action = "single > crop"
          ;
          If area_aspect > image_aspect
            cut_width = ImageWidth(#i_wallpaper_input)
            cut_height = x_min( ImageHeight(#i_wallpaper_input) , ImageWidth(#i_wallpaper_input) / area_aspect * 100 / (100-aspect_distort/2) )
            cut_x = 0
            cut_y = (ImageHeight(#i_wallpaper_input)-cut_height)/2
          Else
            cut_height = ImageHeight(#i_wallpaper_input)
            cut_width = x_min( ImageWidth(#i_wallpaper_input) , ImageHeight(#i_wallpaper_input) * area_aspect * 100 / (100-aspect_distort/2) )
            cut_x = (ImageWidth(#i_wallpaper_input)-cut_width)/2
            cut_y = 0
          EndIf
          StartDrawing(ImageOutput(#i_wallpaper_input))
            GrabDrawingImage(#i_temp3,cut_x,cut_y,cut_width,cut_height)
          StopDrawing()
          StartDrawing(ImageOutput(#i_wallpaper_output))
            DrawImage(ImageID(#i_temp3),area_x,area_y,area_width,area_height)
          StopDrawing()
          FreeImage(#i_temp3)
          ;
        EndIf
        ;
      Next
      ;
    EndIf
    FreeImage(#i_wallpaper_input)
    ;
  EndIf
  ;
EndProcedure

Procedure fitfile(file.s)
  Protected image_aspect.f, cut_height.i, cut_width.i, cut_x.i, cut_y.i, retval.i
  ;
  ; *** stretch image to match destination monitor, ignore aspect ratio, crop etc.
  ;
  ; - this is the dumb version of loadfile()
  ;
  file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
  ;
  If LoadImage(#i_wallpaper_input,file) = 0
    ;
    lastfile_action = "no image"
    ;
    If silent
    Else
      MessageRequester("WallX "+#program_version,"Missing image file"+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok|#MB_ICONERROR)
    EndIf
    ;
  Else
    ;
    ; wallpaper_aspect = wallpaper_width / wallpaper_height
    ; image_aspect = ImageWidth(2)/ImageHeight(2)
    ;
    lastfile_width = ImageWidth(#i_wallpaper_input)
    lastfile_height = ImageHeight(#i_wallpaper_input)
    lastfile_aspect = lastfile_width / lastfile_height
    lastfile_filename = file.s
    lastfile_action = "fit > stretch"
    ;
    For area_n = area_first To area_last
      getdesktopposition(area_n)
      area_filename(area_n) = file                                                                                     ; store name so it can be shown with the markup command
      ;
      lastfile_action = "fit > stretch+distort"
      ;
      StartDrawing(ImageOutput(#i_wallpaper_output))
        DrawImage(ImageID(#i_wallpaper_input),area_x,area_y,area_width,area_height)
      StopDrawing()
      ;
    Next
    FreeImage(#i_wallpaper_input)
    ;
  EndIf
  ;
EndProcedure

Procedure spanfile(file.s)
  ;
  ; *** stretch given file to cover full desktop (span)
  ;
  file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
  ;
  If LoadImage(#i_wallpaper_input,file) = 0
    ;
    lastfile_action = "no image"
    ;
    If silent
    Else
      MessageRequester("WallX "+#program_version,"Missing image file"+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok|#MB_ICONERROR)
    EndIf
    ;
  Else
    ;
    wallpaper_aspect = wallpaper_width / wallpaper_height
    ;
    lastfile_width = ImageWidth(#i_wallpaper_input)
    lastfile_height = ImageHeight(#i_wallpaper_input)
    lastfile_aspect = lastfile_width / lastfile_height
    lastfile_filename = file.s
    ;
    lastfile_action = "span"
    ;
    StartDrawing(ImageOutput(#i_wallpaper_output))
      DrawImage(ImageID(#i_wallpaper_input),0,0,wallpaper_width,wallpaper_height)
    StopDrawing()
    ;
    FreeImage(#i_wallpaper_input)
  EndIf
EndProcedure

Procedure loadrandom(path.s)
  Protected NewList file.s(), NewList assign.s()
  Protected x.s, n.i, file.s, p.i, f.s, missing.s, file_n.i, assign_n.i, pick.s, nn.i, draw_last.i, draw_walk.i
  ;
  ; *** load one or more wallpapers from the specified folder
  ;
  ClearList(assign())
  ClearList(file())
  assign_n = 0
  file_n = 0
  ;
  ; modify the path
  ;
  If path = "~currentfolder~"
    path = GetCurrentDirectory()
  ElseIf path = "~programfolder~"
    path = GetPathPart(ProgramFilename())
  ElseIf path = "~tempfolder~"
    path = GetTemporaryDirectory()
  EndIf
  If Right(path,1) <> "\"
    path = path+"\"
  EndIf
  ;
  If ExamineDirectory(1,path,"*.*") > 0
    While NextDirectoryEntry(1)
      If DirectoryEntryType(1) = #PB_DirectoryEntry_File
        f = Trim(LCase(DirectoryEntryName(1)))
        If Len(f) > 4 And ( Right(f,4) = ".png" Or Right(f,4) = ".jpg" Or Right(f,4) = ".bmp" )
          AddElement(file())
          file() = f
          file_n = file_n+1
        EndIf
      EndIf
    Wend
    FinishDirectory(1)
  EndIf
  ;
  ; assign random file to each monitor
  ;
  If file_n > 0
    For n = 0 To desktops_n-1
      SelectElement(file(),Random(file_n-1))
      AddElement(assign())
      assign() = file()
      assign_n = assign_n+1
    Next
  EndIf
  ;
  ; load wallx.lst file
  ;
  pick = ""
  file = path+"wallx.lst"
  If FileSize(file) > 0
    ClearList(file())
    file_n = 0
    ReadFile(1,file)
    While Not Eof(1)
      x = Trim(ReadString(1))
      If Left(x,1) <> ";" And x > "" And FindString(x,".",1) > 0
        AddElement(file())
        file() = x
        file_n = file_n+1
      EndIf
    Wend
    CloseFile(1)
  EndIf
  ;
  ; don't do anything if the list is empty
  ;
  If file_n > 0
    SelectElement(file(),Random(file_n-1))
    pick = file()
    ;
    ; it's important which image is drawn last, if the last one is a multi monitor one it might replace the single monitor ones
    ;
    draw_last = Random(desktops_n-1)
    draw_walk = 1-Random(1)*2
    ;
    ; the wallx.lst file contains either single entry multi monitor files, or multi entry single monitor files
    ;
    If Random(100) > pairs
      If pick > ""
        If CountString(pick,",") = 0                          ; single monitor so the last image drawn is the pick
          ;
          SelectElement(assign(),draw_last)
          assign() = pick
          ;
        ElseIf CountString(pick,",") > desktops_n             ; this is a set with more images than screens so assign at random
          ;
          For n = 0 To desktops_n-1
            SelectElement(assign(),n)
            nn = Random(CountString(pick,","))
            assign() = Trim(StringField(pick,nn+1,","))
          Next n
          ;
        Else                                                  ; set size matches number of screens, spread the images over all screens
          ;
          nn = draw_last
          For n = 0 To CountString(pick,",")
            nn = (nn+n) % desktops_n
            SelectElement(assign(),nn)
            assign() = Trim(StringField(pick,n+1,","))
          Next n
          ;
        EndIf
      EndIf
    EndIf
    ;
    ; draw all images
    ;
    nn = draw_last
    For n = 1 To desktops_n
      nn = nn+draw_walk
      If nn < 0
        nn = desktops_n-1
      ElseIf nn >= desktops_n
        nn = 0
      EndIf
      area_first = nn
      area_last = nn
      SelectElement(assign(),nn)
      If x_existx(path+assign())
        loadfile(path+assign())
      ElseIf silent = #False
        MessageRequester("WallX "+#program_version,"Missing image file"+#CRLF$+#CRLF$+path+assign(),#PB_MessageRequester_Ok|#MB_ICONERROR)
      EndIf
    Next n
    ;
  EndIf
  ;
EndProcedure

Procedure executecommands()
  Protected color.i, x.i, y.i, xx.i, yy.i, n.i, c.i
  Protected t.s, tt.s, nn.i, p.i
  Protected wall_current.s
  Protected command.s, parameter.s
  Protected r.RECT, taskbarheight.i
  ;
  ;
  ; *** process list of commands
  ;
  silent = #False
  transparent = #False
  fontcolor = $FFFFFF
  ;
  command_error = #False
  command_n = x_commandcount(commandline)
  ;
  lastfile_action = ""
  lastfile_aspect = 0
  lastfile_filename = ""
  lastfile_height = 0
  lastfile_width = 0
  ;
  stayresident = #False
  keep = #False
  pre10 = #False
  ;
  If command_n > 0
    ;
    ; create image
    ;
    CreateImage(#i_wallpaper_output,wallpaper_width,wallpaper_height,24)
    StartDrawing(ImageOutput(#i_wallpaper_output))
      FrontColor(RGB(64+Random(64),64+Random(64),64+Random(64)))
      Box(0,0,wallpaper_width,wallpaper_height)
    StopDrawing()
    ;
    ; default desktop stuff
    ;
    area_selected = -1
    area_first = 0
    area_last = desktops_n-1
    getdesktopposition(-1)
    ;
    ; go through all commands in the list
    ;
    p = 1
    Repeat
      ;
      If area_selected = -1
        area_first = 0
        area_last = desktops_n-1
      Else
        area_first = area_selected
        area_last = area_selected
      EndIf
      ;
      command = x_commandfield(commandline,p)
      parameter = x_commandfield(commandline,p+1)
      ;
      Select x_commandfield(commandline,p)
          Case ""
            ;
            ; nothing, last entry, whatever, just skip
            ;
            p = p+1
            ;
          Case "silent"
            ;
            ; skip alerts on missing files and other problems
            ;
            silent = #True
            p = p+1
            ;
          Case "distort"
            ;
            ; set maximal distortion for multi monitor images
            ; image is stretched to specified limit, above that it is cropped
            ;
            aspect_distort = Val(parameter)
            p = p+2
            ;
          Case "expand"
            ;
            ; maximal expansion (resize) of suitable multi monitor wallpapers with a (too) low resolution
            ;
            multi_expand = Val(parameter)
            p = p+2
            ;
          Case "transparent"
            ;
            ; all subsequent superimposed text will be transparent
            ;
            transparent =  #True
            p = p+1
            ;
          Case "solid"
            ;
            transparent = #False
            p = p+1
            ;
          Case "desktop", "monitor"
            ;
            ; selected desktop aka monitor to send output to, 'all' for all
            ;
            If parameter = "all"
              area_selected = -1
              area_first = 0
              area_last = desktops_n-1
            Else
              area_selected = Val(parameter)
              area_first = area_selected
              area_last = area_selected
            EndIf
            getdesktopposition(area_selected)
            p = p+2
            ;
          Case "markup"
            ;
            ; markup each monitor
            ;
            ; 1. lines to mark boundaries of each monitor
            ; 2. lines to mark boundaries and center of desktop
            ; 3. miniature centered on primary
            ; 4. info block per screen
            ; 5. info block for the whole desktop
            ;
            For area_n = 0 To desktops_n
              getdesktopposition(area_n)
              StartDrawing(ImageOutput(#i_wallpaper_output))
                DrawingMode(#PB_2DDrawing_Default)
                For x = area_x To area_x+area_width-4 Step 4
                  FrontColor(RGB($FF,$FF,$FF))
                  Box(x,area_y,2,2)
                  Box(x,area_y+area_height-2,2,2)
                  FrontColor(RGB($00,$00,$00))
                  Box(x+2,area_y,2,2)
                  Box(x+2,area_y+area_height-2,2,2)
                Next
                For y = area_y To area_y+area_height-4 Step 4
                  FrontColor(RGB($FF,$FF,$FF))
                  Box(area_x,y,2,2)
                  Box(area_x+area_width-2,y,2,2)
                  FrontColor(RGB($00,$00,$00))
                  Box(area_x,y+2,2,2)
                  Box(area_x+area_width-2,y+2,2,2)
                Next
              StopDrawing()
            Next
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_Transparent)
              wallpaper_aspect = wallpaper_width/wallpaper_height
              FrontColor(RGB($FF,$FF,$FF))
              LineXY(0,0,wallpaper_width-1,wallpaper_height-1)
              LineXY(wallpaper_width-1,0,0,wallpaper_height-1)
              LineXY(0,0,40,20)
              LineXY(0,0,20,40)
              LineXY(0,0,45,10)
              LineXY(0,0,10,45)
              LineXY(0,0,30,30)
            StopDrawing()
            ;
            getdesktopposition(0)
            GrabImage(#i_wallpaper_output,#i_temp4,0,0,wallpaper_width,wallpaper_height)
            x = area_x+area_width/2-wallpaper_width/20
            y = area_y+area_height/2-wallpaper_height/20
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawImage(ImageID(#i_temp4),x,y,wallpaper_width/10,wallpaper_height/10)
            StopDrawing()
            ;
            For area_n = 0 To desktops_n
              getdesktopposition(area_n)
              StartDrawing(ImageOutput(#i_wallpaper_output))
                DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
                x = area_x+29
                y = area_y+20
                DrawText(x,y+0,"area "+Str(area_n))
                DrawText(x,y+20,"x "+Str(area_x))
                DrawText(x,y+40,"y "+Str(area_y))
                DrawText(x,y+60,"w "+Str(area_width))
                DrawText(x,y+80,"h "+Str(area_height))
                DrawText(x,y+100,"r "+x_strex(area_aspect*100,"<#.##"))
                DrawText(x,y+120,"file "+area_filename(n))
              StopDrawing()
            Next
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_Transparent)
              wallpaper_aspect = wallpaper_width/wallpaper_height
              x = wallpaper_width/2+20
              y = wallpaper_height/2-140
              DrawText(x,y+0,"wallpaper")
              DrawText(x,y+20,"x "+Str(wallpaper_x))
              DrawText(x,y+40,"y "+Str(wallpaper_y))
              DrawText(x,y+60,"w "+Str(wallpaper_width))
              DrawText(x,y+80,"h "+Str(wallpaper_height))
              DrawText(x,y+100,"r "+x_strex(wallpaper_aspect*100,"<#.##"))
              DrawText(x,y+140,"lastfile "+lastfile_filename)
              DrawText(x,y+160,"w "+Str(lastfile_width))
              DrawText(x,y+180,"h "+Str(lastfile_height))
              DrawText(x,y+200,"r "+x_strex(lastfile_aspect*100,"<#.##"))
              DrawText(x,y+220,"lastaction "+lastfile_action)
              DrawText(x,y+260,"parameters "+commandline)
            StopDrawing()
            ;
            p = p+1
            ;
          Case "red" , "green" , "blue" , "yellow", "pink" , "lime" , "black" , "white" , "grey", "brown", "cyan", "orange"
            ;
            ; one colour full-screen, per monitor
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              StartDrawing(ImageOutput(#i_wallpaper_output))
                DrawingMode(#PB_2DDrawing_Default)
                Select command
                    Case "red"
                      FrontColor(RGB($7F,$00,$00))         ; 50% red
                    Case "green"
                      FrontColor(RGB($00,$7F,$00))         ; 50% green
                    Case "blue"
                      FrontColor(RGB($00,$00,$7F))         ; 50% blue
                    Case "yellow"
                      FrontColor(RGB($AF,$AF,$00))         ; 75% yellow
                    Case "black"
                      FrontColor(0)                        ; full black
                    Case "white"
                      FrontColor($FFFFFF)                  ; full white
                    Case "grey"
                      FrontColor($3F3F3F)                  ; 25% grey
                    Case "cyan"
                      FrontColor(RGB($00,$FF,$FF))         ; typical cyan
                    Case "brown"
                      FrontColor(RGB($80,$40,$00))         ; typical brown
                    Case "pink"
                      FrontColor(RGB($E0,$20,$60))         ; an awful pink :-)
                    Case "lime"
                      FrontColor(RGB($A0,$F0,$00))         ; another awful colour :-)
                    Case "orange"
                      FrontColor(RGB($FF,$80,$00))         ; hard orange
                EndSelect
                Box(area_x,area_y,area_width,area_height)
              StopDrawing()
            Next
            p = p+1
            ;
          Case "color"
            ;
            ; use spedified colour, per monitor
            ;
            t = parameter
            If Len(t) = 7
              t = Right(t,6)
            EndIf
            If Len(t) = 6
              color = RGB(Val("$"+Mid(t,1,2)),Val("$"+Mid(t,3,2)),Val("$"+Mid(t,5,2)))
              For area_n = area_first To area_last
                getdesktopposition(area_n)
                ;
                StartDrawing(ImageOutput(#i_wallpaper_output))
                  DrawingMode(#PB_2DDrawing_Default)
                  FrontColor(color)
                  Box(area_x,area_y,area_width,area_height)
                StopDrawing()
              Next
            EndIf
            p = p+2
            ;
          Case "base"
            ;
            ; yellow diagonals on black background, all monitors
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_Default)
              Box(0,0,wallpaper_width,wallpaper_height,0)
              x = 0-wallpaper_width
              Repeat
                x = x+wallpaper_width/6
                For xx=x To x+wallpaper_width/13
                  LineXY(xx,0,xx+wallpaper_width,wallpaper_width,RGB($FF,$FF,$00))
                Next xx
              Until x > wallpaper_width
            StopDrawing()
            p = p+1
            ;
          Case "traffic"
            ;
            ; red diagonals on a white background, all monitors
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_Default)
              Box(0,0,wallpaper_width,wallpaper_height,$FFFFFF)
              x = 0-wallpaper_width
              Repeat
                x = x+wallpaper_width/10
                For xx=x To x+wallpaper_width/20
                  LineXY(xx,0,xx+wallpaper_width,wallpaper_width,$0000FF)
                Next xx
              Until x > wallpaper_width
            StopDrawing()
            p = p+1
            ;
          Case "drain"
            ;
            ; drain all color and darken a little, all monitors
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_Default)
              For x = 0 To wallpaper_width-1
                For y = 0 To wallpaper_height-1
                  c = Point(x,y)
                  c = 0.2*Red(c)+0.2*Blue(c)+0.3*Green(c)
                  Plot(x,y,RGB(c,c,c))
                Next y
              Next x
            StopDrawing()
            p = p+1
            ;
          Case "blur"
            ;
            ; GrabImage(#i_1,#i_2,wallpaper_width*0.01+4,wallpaper_height*0.01+4,wallpaper_width*0.99-8,wallpaper_height*0.99-8)
            ; ResizeImage(2,wallpaper_width+2,wallpaper_height+2)
            ;
            CopyImage(#i_wallpaper_output,#i_wallpaper_input)
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_Default)
              DrawAlphaImage(ImageID(#i_wallpaper_input),-1,1,32)
              DrawAlphaImage(ImageID(#i_wallpaper_input),-2,-1,64)
              DrawAlphaImage(ImageID(#i_wallpaper_input),2,1,64)
              DrawAlphaImage(ImageID(#i_wallpaper_input),1,-1,32)
            StopDrawing()
            p = p+1
            ;
          Case "dots"
            ;
            ; small pattern of black dots (25%), per monitor
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              ;
              StartDrawing(ImageOutput(#i_wallpaper_output))
                DrawingMode(#PB_2DDrawing_Default)
                x = 2
                While x < area_width+1
                  y = 2
                  While y < area_height-1
                    Box(area_x+x,area_y+y,2,2,0)
                    y = y+4
                  Wend
                  x = x+4
                Wend
              StopDrawing()
            Next
            p = p+1
            ;
          Case "fade"
            ;
            ; fade to black top to bottom, per monitor
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              ;
              StartDrawing(ImageOutput(#i_wallpaper_output))
                DrawingMode(#PB_2DDrawing_AlphaBlend)
                For y = 0 To area_height-1
                  LineXY(area_x+0,area_y+y,area_x+area_width-1,area_y+y,y*255/area_height*$1000000)
                Next y
              StopDrawing()
            Next area_n
            p = p+1
            ;
          Case "round"
            ;
            ; round the corners of the wallpaper, take taskbar into account
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              SystemParametersInfo_(#SPI_GETWORKAREA,0,@r,0)                      ; get dimensions of workarea
              taskbarheight = GetSystemMetrics_(#SM_CYSCREEN)-(r\bottom-r\top+1)  ; taskbarheight = screensize-workarea
              CreateImage(#i_temp4,area_width,area_height,32)
              StartDrawing(ImageOutput(#i_temp4))
                DrawingMode(#PB_2DDrawing_Default)
                Box(0,0,area_width,area_height,$000000)
                DrawingMode(#PB_2DDrawing_AlphaChannel)
                RoundBox(0,0,area_width,area_height-taskbarheight,taskbarheight,taskbarheight,$00000000)
              StopDrawing()
              StartDrawing(ImageOutput(#i_wallpaper_output))
                DrawingMode(#PB_2DDrawing_AlphaBlend)
                DrawAlphaImage(ImageID(#i_temp4),area_x,area_y,255)
              StopDrawing()
            Next area_n
            p = p+1
            FreeImage(#i_temp4)
            ;
          Case "darken"
            ;
            ; darken the image 25%
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_AlphaBlend)
              Box(0,0,wallpaper_width,wallpaper_height,RGBA(0,0,0,64))
            StopDrawing()
            p = p+1
            ;
          Case "invert"
            ;
            ; make a negative of the image
            ;
            StartDrawing(ImageOutput(#i_wallpaper_output))
              DrawingMode(#PB_2DDrawing_XOr)
              Box(0,0,wallpaper_width,wallpaper_height,RGBA(255,255,255,255))
            StopDrawing()
            p = p+1
            ;
          Case "reverse"
            ;
            ; black text with white shadows
            ;
            fontcolor = $FFFFFF-fontcolor
            p = p+1
            ;
          Case "font"
            ;
            ; select font to use
            ;
            fontname = parameter
            fontsize = Val(x_commandfield(commandline,p+2))
            p = p+3
            ;
          Case "big"
            ;
            ; big background text in white, per monitor
            ;
            ; font name as specified by 'font <fontname> <fontsize>'
            ; font size hardcoded
            ; use for other fontsizes the option 'text'
            ;
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              ;
              t.s = maketext(parameter)
              If CountString(t.s,".") = 3
                t.s = StringField(t.s,4,".")
                If t.s = ""
                  t.s = maketext(parameter)
                EndIf
              EndIf
              LoadFont(1,fontname,area_height*6/9,#PB_Font_Bold|#PB_Font_HighQuality)
              StartDrawing(ImageOutput(#i_wallpaper_output))
                If transparent
                  DrawingMode(#PB_2DDrawing_AlphaBlend)
                Else
                  DrawingMode(#PB_2DDrawing_Transparent)
                EndIf
                DrawingFont(FontID(1))
                DrawText(area_x+area_width/2-TextWidth(t)/2,area_y+area_height/2-TextHeight(t)/2,t,fontcolor+64*$1000000,256*$1000000)
              StopDrawing()
              FreeFont(1)
            Next
            p = p+2
            ;
          Case "text"
            ;
            ; foreground text in 100% with black shadow, per monitor
            ;
            ; font name and size specified by 'font <fontname> <fontsize>'
            ;
            LoadFont(2,fontname,fontsize,#PB_Font_Bold|#PB_Font_HighQuality)
            LoadFont(3,fontname,fontsize/2,#PB_Font_Bold|#PB_Font_HighQuality)
            For area_n = area_first To area_last
              getdesktopposition(area_n)
              t.s = maketext(parameter)
              StartDrawing(ImageOutput(#i_wallpaper_output))
                If transparent
                  DrawingMode(#PB_2DDrawing_AlphaBlend)
                Else
                  DrawingMode(#PB_2DDrawing_Transparent)
                EndIf
                n = CountString(t,"|")+1
                nn = 0
                While nn < n
                  nn = nn+1
                  tt.s = Trim(StringField(t,nn,"|"))
                  If tt.s = ""
                  ElseIf nn = 1
                    DrawingFont(FontID(2))
                    DrawText(area_x+area_width/2-TextWidth(tt)/2+2,area_y+area_height/2-fontsize/2+2,tt,$FFFFFF-fontcolor+16*$1000000,256*$1000000)
                    DrawText(area_x+area_width/2-TextWidth(tt)/2,area_y+area_height/2-fontsize/2,tt,fontcolor+96*$1000000,256*$1000000)
                  Else
                    DrawingFont(FontID(3))
                    DrawText(area_x+area_width/2-TextWidth(tt)/2+2,area_y+area_height/2-fontsize*0.4+fontsize*0.8*nn+2,tt,$FFFFFF-fontcolor+16*$1000000,256*$1000000)
                    DrawText(area_x+area_width/2-TextWidth(tt)/2,area_y+area_height/2-fontsize*0.4+fontsize*0.8*nn,tt,fontcolor+96*$1000000,256*$1000000)
                  EndIf
                Wend
              StopDrawing()
            Next
            FreeFont(2)
            FreeFont(3)
            p = p+2
            ;
          Case "load"
            ;
            ; load the specified image, or the one currently selected in the control panel
            ; try to be smart regarding multi monitor handling and resizing
            ;
            loadfile(parameter)
            p = p+2
            ;
          Case "span"
            ;
            ; load the specified image, or the one currently selected in the control panel
            ; then span it over all monitors
            ;
            spanfile(parameter)
            p = p+2
            ;
          Case "fit"
            ;
            ; load the specified image, or the one currently selected in the control panel
            ; then resize it to fit current monitor
            ;
            fitfile(parameter)
            p = p+2
            ;
          Case "frompanel"
            ;
            ; load current wallpaper from control panel
            ;
            x_registry_get(#HKEY_CURRENT_USER,"Control Panel\Desktop","Wallpaper")
            If x_registry_s = "" Or FileSize(x_registry_s) <= 0
            Else
              loadfile(x_registry_s)
            EndIf
            p = p+1
            ;
          Case "pairs", "sets"
            ;
            ; set chance for using image pairs from the wallx.lst file
            ;
            pairs = Val(parameter)
            p = p+2
            ;
          Case "keep"
            ;
            keep = #True
            p = p+1
            ;
          Case "random"
            ;
            loadrandom(parameter)
            p = p+2
            ;
          Case "save"
            ;
            ; save the created image under the specified name, all desktops combined
            ;
            wall_filename = parameter
            If wall_filename = "~programfolder~"
              wall_filename = GetPathPart(ProgramFilename())+"wallx.bmp"
            ElseIf wall_filename = "~currentfolder~"
              wall_filename = GetCurrentDirectory()+"wallx.bmp"
            ElseIf wall_filename = "~tempfolder~"
              wall_filename = GetTemporaryDirectory()+"wallx.bmp"
            EndIf
            keep = #True
            p = p+2
            ;
          Case "end"
            ;
            ; end flag, should no longer be required
            ;
            p = p+1
            ;
          Case "resident", "background"
            ;
            ; keep wallx in memory and monitor screen and / or ip changes
            ;
            stayresident = #True
            p = p+1
            ;
          Case "pre10"
            ;
            ; use pre10 method for tiling and setting wallpaper
            ; pre-10: monitor 0 is origin, win10: left top monitor is origin
            ;
            pre10 = #True
            p = p+1
            ;
          Case "kill"
            ;
            ; send a termination message to any wallx instances running
            ;
            PostMessage_(#HWND_BROADCAST,killmessage_nr,0,0)
            p = p+1
            ;
          Case "renew"
            ;
            ; renew wallpaper every 'n' seconds
            ;
            renew = Val(parameter)
            p = p+2
            ;
          Case "nouser"
            ;
            ; only renew wallpaper if the user was not active for 'n' seconds
            ;
            nouser = Val(parameter)
            p = p+2
            ;
          Default
            ;
            ; unknown command / parameter
            ;
            If silent = #False
              MessageRequester("WallX "+#program_version,"Unrecognized command or missing parameter"+#CRLF$+#CRLF$+command,#PB_MessageRequester_Ok|#MB_ICONERROR)
              command_error = #True
            EndIf
            p = p+1
            ;
      EndSelect
    Until p > command_n Or command = "end" Or command = "help" Or command_error = #True
    ;
    If command_error = #False
      ;
      If pre10
        ;
        ; for windows versions before win10
        ; in this case the origin of the tiled wallpaper lies on the primary monitor
        ;
        CreateImage(#i_temp2,wallpaper_width,wallpaper_height)
        For area_n = 0 To desktops_n
          getdesktopposition(area_n)
          GrabImage(#i_wallpaper_output,#i_temp3,area_x,area_y,area_width,area_height)
          StartDrawing(ImageOutput(#i_temp2))
            x = area_x+wallpaper_x
            y = area_y+wallpaper_y
            DrawImage(ImageID(#i_temp3),x,y)
            If x < 0
              DrawImage(ImageID(#i_temp3),x+wallpaper_width,y)
            EndIf
            If x+area_width > wallpaper_width
              DrawImage(ImageID(#i_temp3),x-wallpaper_width,y)
            EndIf
            If y < 0
              DrawImage(ImageID(#i_temp3),x,y+wallpaper_height)
            EndIf
            If y+area_height > wallpaper_height
              DrawImage(ImageID(#i_temp3),x,y-wallpaper_height)
            EndIf
            If x < 0 And y < 0
              DrawImage(ImageID(#i_temp3),x+wallpaper_width,y+wallpaper_height)
            EndIf
            If x > wallpaper_width And y > wallpaper_height
              DrawImage(ImageID(#i_temp3),x-wallpaper_width,y-wallpaper_height)
            EndIf
          StopDrawing()
        Next
        SaveImage(#i_temp2,wall_filename)
        FreeImage(#i_temp2)
        FreeImage(#i_temp3)
        ;
      Else
        ;
        ; win10 and later
        ;
        SaveImage(#i_wallpaper_output,wall_filename)
        ;
      EndIf
      ;
      x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallpaper",#REG_SZ,0,"1",1)
      ;
      ; 0 - the wallpaper picture should not be tiled
      ; 1 - the wallpaper picture should be tiled
      ;
      x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","WallpaperStyle",#REG_SZ,0,"0",1)
      ;
      ; 0  - the image is centered if TileWallpaper=0 or tiled if TileWallpaper=1
      ; 2  - the image is stretched to fill the screen
      ; 6  - the image is resized to fit the screen while maintaining the aspect ratio (win 7 and later)
      ; 10 - the image is resized and cropped to fill the screen while maintaining the aspect ratio (win 7 and later)
      ;
      ; wall_filename = "c:\windows\default.bmp"
      ; x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallpaper",#REG_SZ,0,"0",1)
      ;
      If keep = #True
        ;
        ; first attempt
        ;
        ; SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_UPDATEINIFILE)
        ;
        ; up to v2.00
        ;
        ;SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_SENDWININICHANGE)
        ;SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_UPDATEINIFILE|#SPIF_SENDWININICHANGE)
        ;
        ; next try (seems to be smoother)
        ;
        SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_UPDATEINIFILE)
        SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,#SPIF_SENDWININICHANGE)
      Else
        SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@wall_filename,0)
      EndIf
      ;
      If wall_filename = GetTemporaryDirectory()+"wallx.bmp" And keep = #False
        DeleteFile(wall_filename)
      EndIf
    EndIf
    ;
  EndIf
  ;
EndProcedure

Procedure commandlinetogui()
  Protected command.s, parameter.s, section.i, n.i, transparent.i, reverse.i
  ;
  SetGadgetState(#g_wallpaper,#g_wallpaper__randomcolour)
  SetGadgetText(#g_wallpaper_file,"")
  SetGadgetState(#g_effect1_dots,0)
  SetGadgetState(#g_effect1_fade,0)
  SetGadgetState(#g_effect1_darken,0)
  SetGadgetState(#g_effect1_drain,0)
  SetGadgetState(#g_effect1_blur,0)
  SetGadgetState(#g_effect1_invert,0)
  SetGadgetState(#g_big_transparent,0)
  SetGadgetState(#g_big_reverse,0)
  SetGadgetText(#g_big_text,"")
  SetGadgetState(#g_effect2_dots,0)
  SetGadgetState(#g_effect2_fade,0)
  SetGadgetState(#g_effect2_darken,0)
  SetGadgetState(#g_effect2_drain,0)
  SetGadgetState(#g_effect2_blur,0)
  SetGadgetState(#g_effect2_invert,0)
  SetGadgetText(#g_normal_text,"")
  SetGadgetState(#g_normal_transparent,0)
  SetGadgetState(#g_normal_reverse,0)
  SetGadgetState(#g_effect3_dots,0)
  SetGadgetState(#g_effect3_fade,0)
  SetGadgetState(#g_effect3_darken,0)
  SetGadgetState(#g_effect3_drain,0)
  SetGadgetState(#g_effect3_blur,0)
  SetGadgetState(#g_effect3_invert,0)
  SetGadgetState(#g_effect4_round,0)
  SetGadgetState(#g_markup,0)
  SetGadgetText(#g_distort,"")
  SetGadgetText(#g_expand,"")
  SetGadgetText(#g_renew,"")
  SetGadgetText(#g_nouser,"")
  SetGadgetState(#g_resident,0)
  SetGadgetState(#g_keep,0)
  SetGadgetState(#g_pre10,0)
  ;
  stayresident = #False
  keep = #False
  pre10 = #False
  ;
  command_n = x_commandcount(commandline)
  section = 1
  n = 0
  While n < command_n
    n = n+1
    command = x_commandfield(commandline,n)
    parameter = x_commandfield(commandline,n+1)
    Select command
        Case "load"
          SetGadgetState(#g_wallpaper,#g_wallpaper__loadfile)
          SetGadgetText(#g_wallpaper_file,parameter)
          n = n+1
        Case "fit"
          SetGadgetState(#g_wallpaper,#g_wallpaper__fitfile)
          SetGadgetText(#g_wallpaper_file,parameter)
          n = n+1
        Case "span"
          SetGadgetState(#g_wallpaper,#g_wallpaper__spanfile)
          SetGadgetText(#g_wallpaper_file,parameter)
          n = n+1
        Case "random"
          SetGadgetState(#g_wallpaper,#g_wallpaper__frompath)
          SetGadgetText(#g_wallpaper_file,parameter)
          n = n+1
        Case "transparent"
          transparent = #True
        Case "solid"
          transparent = #False
        Case "reverse"
          reverse = 1 - reverse
        Case "big"
          SetGadgetState(#g_big_transparent,transparent)
          SetGadgetState(#g_big_reverse,reverse)
          SetGadgetText(#g_big_text,parameter)
          section = 2
          n = n+1
        Case "text"
          SetGadgetState(#g_normal_transparent,transparent)
          SetGadgetState(#g_normal_reverse,reverse)
          SetGadgetText(#g_normal_text,parameter)
          section = 3
          n = n+1
        Case "red"
          SetGadgetState(#g_wallpaper,#g_wallpaper__red)
        Case "green"
          SetGadgetState(#g_wallpaper,#g_wallpaper__green)
        Case "blue"
          SetGadgetState(#g_wallpaper,#g_wallpaper__blue)
        Case "yellow"
          SetGadgetState(#g_wallpaper,#g_wallpaper__yellow)
        Case "cyan"
          SetGadgetState(#g_wallpaper,#g_wallpaper__cyan)
        Case "lime"
          SetGadgetState(#g_wallpaper,#g_wallpaper__lime)
        Case "pink"
          SetGadgetState(#g_wallpaper,#g_wallpaper__pink)
        Case "black"
          SetGadgetState(#g_wallpaper,#g_wallpaper__black)
        Case "white"
          SetGadgetState(#g_wallpaper,#g_wallpaper__white)
        Case "grey"
          SetGadgetState(#g_wallpaper,#g_wallpaper__grey)
        Case "traffic"
          SetGadgetState(#g_wallpaper,#g_wallpaper__traffic)
        Case "base"
          SetGadgetState(#g_wallpaper,#g_wallpaper__base)
        Case "distort"
          SetGadgetText(#g_distort,parameter)
          n = n+1
        Case "expand"
          SetGadgetText(#g_expand,parameter)
          n = n+1
        Case "renew"
          SetGadgetText(#g_renew,parameter)
          n = n+1
        Case "nouser"
          SetGadgetText(#g_nouser,parameter)
          n = n+1
        Case "keep"
          SetGadgetState(#g_keep,1)
        Case "resident", "background"
          SetGadgetState(#g_resident,1)
          stayresident = #True
        Case "pre10"
          SetGadgetState(#g_pre10,1)
          pre10 = #True
        Case "markup"
          SetGadgetState(#g_markup,1)
        Case "round"
          SetGadgetState(#g_effect4_round,1)
    EndSelect
    Select section
        Case 1
          Select command
              Case "dots"
                SetGadgetState(#g_effect1_dots,1)
              Case "fade"
                SetGadgetState(#g_effect1_fade,1)
              Case "darken"
                SetGadgetState(#g_effect1_darken,1)
              Case "drain"
                SetGadgetState(#g_effect1_drain,1)
              Case "blur"
                SetGadgetState(#g_effect1_blur,1)
              Case "invert"
                SetGadgetState(#g_effect1_invert,1)
          EndSelect
        Case 2
          Select command
              Case "dots"
                SetGadgetState(#g_effect2_dots,1)
              Case "fade"
                SetGadgetState(#g_effect2_fade,1)
              Case "darken"
                SetGadgetState(#g_effect2_darken,1)
              Case "drain"
                SetGadgetState(#g_effect2_drain,1)
              Case "blur"
                SetGadgetState(#g_effect2_blur,1)
              Case "invert"
                SetGadgetState(#g_effect2_invert,1)
          EndSelect
        Case 3
          Select command
              Case "dots"
                SetGadgetState(#g_effect3_dots,1)
              Case "fade"
                SetGadgetState(#g_effect3_fade,1)
              Case "darken"
                SetGadgetState(#g_effect3_darken,1)
              Case "drain"
                SetGadgetState(#g_effect3_drain,1)
              Case "blur"
                SetGadgetState(#g_effect3_blur,1)
              Case "invert"
                SetGadgetState(#g_effect3_invert,1)
          EndSelect
    EndSelect
  Wend
  ;
EndProcedure

Procedure guitocommandline()
  Protected t.s
  ;
  commandline = ""
  ;
  Select GetGadgetState(#g_wallpaper)
      Case #g_wallpaper__randomcolour
      Case #g_wallpaper__red
        commandline = commandline+" red"
      Case #g_wallpaper__green
        commandline = commandline+" green"
      Case #g_wallpaper__blue
        commandline = commandline+" blue"
      Case #g_wallpaper__yellow
        commandline = commandline+" yellow"
      Case #g_wallpaper__cyan
        commandline = commandline+" cyan"
      Case #g_wallpaper__lime
        commandline = commandline+" lime"
      Case #g_wallpaper__orange
        commandline = commandline+" orange"
      Case #g_wallpaper__pink
        commandline = commandline+" pink"
      Case #g_wallpaper__black
        commandline = commandline+" black"
      Case #g_wallpaper__grey
        commandline = commandline+" grey"
      Case #g_wallpaper__white
        commandline = commandline+" white"
      Case #g_wallpaper__traffic
        commandline = commandline+" traffic"
      Case #g_wallpaper__base
        commandline = commandline+" base"
      Case #g_wallpaper__loadfile
        commandline = commandline+" load "+#DQUOTE$+GetGadgetText(#g_wallpaper_file)+#DQUOTE$
      Case #g_wallpaper__spanfile
        commandline = commandline+" span "+#DQUOTE$+GetGadgetText(#g_wallpaper_file)+#DQUOTE$
      Case #g_wallpaper__fitfile
        commandline = commandline+" fit "+#DQUOTE$+GetGadgetText(#g_wallpaper_file)+#DQUOTE$
      Case #g_wallpaper__frompath
        commandline = commandline+" random "+#DQUOTE$+GetGadgetText(#g_wallpaper_file)+#DQUOTE$
      Case #g_wallpaper__programfolder
        commandline = commandline+" random ~programfolder~"
  EndSelect
  ;
  If GetGadgetState(#g_effect1_dots)
    commandline = commandline+" dots"
  EndIf
  If GetGadgetState(#g_effect1_fade)
    commandline = commandline+" fade"
  EndIf
  If GetGadgetState(#g_effect1_darken)
    commandline = commandline+" darken"
  EndIf
  If GetGadgetState(#g_effect1_drain)
    commandline = commandline+" drain"
  EndIf
  If GetGadgetState(#g_effect1_invert)
    commandline = commandline+" invert"
  EndIf
  If GetGadgetState(#g_effect1_blur)
    commandline = commandline+" blur"
  EndIf
  ;
  t = GetGadgetText(#g_big_text)
  If t > ""
    If GetGadgetState(#g_big_transparent)
      commandline = commandline+" transparent"
    EndIf
    If GetGadgetState(#g_big_reverse)
      commandline = commandline+" reverse"
    EndIf
    commandline = commandline+" big "+Chr(34)+t+Chr(34)
  EndIf
  ;
  If GetGadgetState(#g_effect2_dots)
    commandline = commandline+" dots"
  EndIf
  If GetGadgetState(#g_effect2_fade)
    commandline = commandline+" fade"
  EndIf
  If GetGadgetState(#g_effect2_darken)
    commandline = commandline+" darken"
  EndIf
  If GetGadgetState(#g_effect2_drain)
    commandline = commandline+" drain"
  EndIf
  If GetGadgetState(#g_effect2_invert)
    commandline = commandline+" invert"
  EndIf
  If GetGadgetState(#g_effect2_blur)
    commandline = commandline+" blur"
  EndIf
  ;
  t = GetGadgetText(#g_normal_text)
  If t > ""
    If GetGadgetState(#g_normal_transparent)
      commandline = commandline+" transparent"
    ElseIf GetGadgetState(#g_big_transparent)
      commandline = commandline+" solid"
    EndIf
    If GetGadgetState(#g_normal_reverse) <> GetGadgetState(#g_big_reverse)
      commandline = commandline+" reverse"
    EndIf
    commandline = commandline+" text "+Chr(34)+t+Chr(34)
  EndIf
  ;
  If GetGadgetState(#g_effect3_dots)
    commandline = commandline+" dots"
  EndIf
  If GetGadgetState(#g_effect3_fade)
    commandline = commandline+" fade"
  EndIf
  If GetGadgetState(#g_effect3_darken)
    commandline = commandline+" darken"
  EndIf
  If GetGadgetState(#g_effect3_drain)
    commandline = commandline+" drain"
  EndIf
  If GetGadgetState(#g_effect3_invert)
    commandline = commandline+" invert"
  EndIf
  If GetGadgetState(#g_effect3_blur)
    commandline = commandline+" blur"
  EndIf
  ;
  If GetGadgetState(#g_effect4_round)
    commandline = commandline+" round"
  EndIf
  If GetGadgetState(#g_markup)
    commandline = commandline+" markup"
  EndIf
  ;
  t = GetGadgetText(#g_distort)
  If t > ""
    commandline = commandline+" distort "+Str(Val(t))
  EndIf
  t = GetGadgetText(#g_expand)
  If t > ""
    commandline = commandline+" expand "+Str(Val(t))
  EndIf
  ;
  t = GetGadgetText(#g_renew)
  If t > ""
    commandline = commandline+" renew "+Str(Val(t))
  EndIf
  t = GetGadgetText(#g_nouser)
  If t > ""
    commandline = commandline+" nouser "+Str(Val(t))
  EndIf
  ;
  If GetGadgetState(#g_keep)
    commandline = commandline+" keep"
  EndIf
  If GetGadgetState(#g_resident)
    commandline = commandline+" resident"
  EndIf
  If GetGadgetState(#g_pre10)
    commandline = "pre10 "+commandline
  EndIf
  ;
  commandline = Trim(commandline)
  command_n = x_commandcount(commandline)
  SetGadgetText(#g_commandline,commandline)
  ;
EndProcedure

Procedure.s iconfromlnk(file.s)
  Protected result.s = Space(#MAX_PATH + 1)
  Protected linkFile.IPersistFile
  Protected shellLink.IShellLinkW
  Protected IconIndexInFile.l
  ;
  ; credit for the code in this procedure goes to AZJIO in the PureBasic forum
  ;
  CoInitialize_(0)
  ;
  DataSection
    CLSID_ShellLink:
    ; 00021401-0000-0000-C000-000000000046
    Data.l $00021401
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    ;
    IID_IShellLink:
    CompilerIf #PB_Compiler_Unicode
      ; IID_IShellLinkW
      ; {000214F9-0000-0000-C000-000000000046}
      Data.l $000214F9
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerElse
      ; 000214EE-0000-0000-C000-000000000046
      Data.l $000214EE
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerEndIf
    ;
    IID_IPersistFile:
    ; 0000010b-0000-0000-C000-000000000046
    Data.l $0000010b
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
  EndDataSection
  ;
  If CoCreateInstance_(?CLSID_ShellLink, 0, 1, ?IID_IShellLink, @shellLink) = #S_OK
    If shellLink\QueryInterface(?IID_IPersistFile, @linkFile) = #S_OK
      If linkFile\Load(file, 0) = #S_OK
        If shellLink\Resolve(0, 1) = #S_OK
          shellLink\getIconLocation(@result, #MAX_PATH, @IconIndexInFile)
          If result = ""
            shellLink\GetPath(@result, #MAX_PATH, 0, 0)
          EndIf
        EndIf
      EndIf
      LinkFile\Release()
    EndIf
    shellLink\Release()
  EndIf
  ;
  CoUninitialize_()
  ;
  ProcedureReturn result
EndProcedure

Procedure.s targetfromlnk(file.s)
  Protected result.s = Space(#MAX_PATH + 1)
  Protected linkFile.IPersistFile
  Protected shellLink.IShellLinkW
  Protected IconIndexInFile.l
  ;
  ; credit for the code in this procedure goes to AZJIO in the PureBasic forum
  ;
  CoInitialize_(0)
  ;
  DataSection
    CLSID_ShellLink:
    ; 00021401-0000-0000-C000-000000000046
    Data.l $00021401
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    ;
    IID_IShellLink:
    CompilerIf #PB_Compiler_Unicode
      ; IID_IShellLinkW
      ; {000214F9-0000-0000-C000-000000000046}
      Data.l $000214F9
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerElse
      ; 000214EE-0000-0000-C000-000000000046
      Data.l $000214EE
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerEndIf
    ;
    IID_IPersistFile:
    ; 0000010b-0000-0000-C000-000000000046
    Data.l $0000010b
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
  EndDataSection
  ;
  If CoCreateInstance_(?CLSID_ShellLink, 0, 1, ?IID_IShellLink, @shellLink) = #S_OK
    If shellLink\QueryInterface(?IID_IPersistFile, @linkFile) = #S_OK
      If linkFile\Load(file, 0) = #S_OK
        If shellLink\Resolve(0, 1) = #S_OK
          shellLink\GetPath(@result, #MAX_PATH, 0, 0)
        EndIf
      EndIf
      LinkFile\Release()
    EndIf
    shellLink\Release()
  EndIf
  ;
  CoUninitialize_()
  ;
  ProcedureReturn result
EndProcedure

Procedure.s parametersfromlnk(file.s)
  Protected result.s = Space(#MAX_PATH + 1)
  Protected linkFile.IPersistFile
  Protected shellLink.IShellLinkW
  Protected IconIndexInFile.l
  ;
  ; credit for the code in this procedure goes to AZJIO in the PureBasic forum
  ;
  CoInitialize_(0)
  ;
  DataSection
    CLSID_ShellLink:
    ; 00021401-0000-0000-C000-000000000046
    Data.l $00021401
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    ;
    IID_IShellLink:
    CompilerIf #PB_Compiler_Unicode
      ; IID_IShellLinkW
      ; {000214F9-0000-0000-C000-000000000046}
      Data.l $000214F9
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerElse
      ; 000214EE-0000-0000-C000-000000000046
      Data.l $000214EE
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerEndIf
    ;
    IID_IPersistFile:
    ; 0000010b-0000-0000-C000-000000000046
    Data.l $0000010b
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
  EndDataSection
  ;
  If CoCreateInstance_(?CLSID_ShellLink, 0, 1, ?IID_IShellLink, @shellLink) = #S_OK
    If shellLink\QueryInterface(?IID_IPersistFile, @linkFile) = #S_OK
      If linkFile\Load(file, 0) = #S_OK
        If shellLink\Resolve(0, 1) = #S_OK
          shellLink\GetArguments(@result, #MAX_PATH)
        EndIf
      EndIf
      LinkFile\Release()
    EndIf
    shellLink\Release()
  EndIf
  ;
  CoUninitialize_()
  ;
  ProcedureReturn result
EndProcedure

Procedure.s workingfolderfromlnk(file.s)
  Protected result.s = Space(#MAX_PATH + 1)
  Protected linkFile.IPersistFile
  Protected shellLink.IShellLinkW
  Protected IconIndexInFile.l
  ;
  ; credit for the code in this procedure goes to AZJIO in the PureBasic forum
  ;
  CoInitialize_(0)
  ;
  DataSection
    CLSID_ShellLink:
    ; 00021401-0000-0000-C000-000000000046
    Data.l $00021401
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    ;
    IID_IShellLink:
    CompilerIf #PB_Compiler_Unicode
      ; IID_IShellLinkW
      ; {000214F9-0000-0000-C000-000000000046}
      Data.l $000214F9
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerElse
      ; 000214EE-0000-0000-C000-000000000046
      Data.l $000214EE
      Data.w $0000,$0000
      Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    CompilerEndIf
    ;
    IID_IPersistFile:
    ; 0000010b-0000-0000-C000-000000000046
    Data.l $0000010b
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
  EndDataSection
  ;
  If CoCreateInstance_(?CLSID_ShellLink, 0, 1, ?IID_IShellLink, @shellLink) = #S_OK
    If shellLink\QueryInterface(?IID_IPersistFile, @linkFile) = #S_OK
      If linkFile\Load(file, 0) = #S_OK
        If shellLink\Resolve(0, 1) = #S_OK
          shellLink\GetWorkingDirectory(@result, #MAX_PATH)
        EndIf
      EndIf
      LinkFile\Release()
    EndIf
    shellLink\Release()
  EndIf
  ;
  CoUninitialize_()
  ;
  ProcedureReturn result
EndProcedure

Procedure drawiconfile(file.s,image_h.i,x,y,w)
  Protected n.i
  Protected Dim large.i(2), Dim small.i(2)
  Protected hicon.i
  ;
  ; *** draw file on image at specified location
  ;
  ; notes on previous coding attempts
  ;
  ; this works, output is always 32x32
  ;
  ;       h = ExtractIcon_(0,file,0)
  ;       SetGadgetState(#g_icon_image,h)
  ;       Debug h
  ;       DestroyIcon_(h)
  ;
  ; this works, allows 16x16, but doesn't handle explorer.exe wihtout a path
  ;
  ;      h = ExtractIcon_(0,file,0)
  ;      CreateImage(10,16,16)
  ;      StartDrawing(ImageOutput(10))
  ;        DrawImage(h,0,0,16,16)
  ;      StopDrawing()
  ;      SetGadgetState(#g_icon_image,ImageID(10))
  ;      DestroyIcon_(h)
  ;
  ; and this works, and does support filenames without paths (probably searching defined paths)
  ;
  ;       file = "explorer.exe"
  ;       Dim large.i(2)
  ;       Dim small.i(2)
  ;       n = ExtractIconEx_(file,-1,0,0,0)
  ;       Debug n
  ;       ExtractIconEx_(file,0,large(),small(),1)
  ;       CreateImage(10,16,16)
  ;       h=StartDrawing(ImageOutput(10))
  ;         DrawIconEx_(h,0,0,small(0),16,16,0,0,#DI_NORMAL)
  ;       StopDrawing()
  ;       SetGadgetState(#g_icon_image,ImageID(10))
  ;       DestroyIcon_(small(0))
  ;       DestroyIcon_(large(0))
  ;
  ; for debugging purposes
  ;
  ;   DrawingMode(#PB_2DDrawing_Default)
  ;   Box(0,0,w,w,$FF0000)
  ;
  If x_existx(file) And (Right(file,4)=".bmp" Or Right(file,4)=".jpg" Or Right(file,4)=".png")
    If LoadImage(#i_temp4,file,0)
      DrawImage(ImageID(#i_temp4),x,y,w,w)
    EndIf
  ElseIf Right(file,4) = ".bat"
    DrawImage(i_batch_h,x,y,w,w)
  ElseIf Left(file,7) = "http://" Or Left(file,8) = "https://"
    DrawImage(i_web_h,x,y,w,w)
  ElseIf file = "~wallx~"
    DrawImage(i_wallnut_h,x,y,w,w)
  ElseIf file = "" Or file = "~empty~" Or file = "------" Or file = "~separator~"
    DrawImage(i_empty_h,x,y,w,w)
  ElseIf file = "~missing~"
    DrawImage(i_missing_h,x,y,w,w)
  Else
    n = ExtractIconEx_(file,-1,0,0,0)
    If n > 0
      CallFunctionFast(p_shextracticonsw,@file,0,128,128,@hicon,0,1,0)
      DrawIconEx_(image_h,x,y,hicon,w,w,0,0,#DI_NORMAL)
      DestroyIcon_(hicon)
    Else
      DrawImage(i_missing_h,x,y,w,w)
    EndIf
  EndIf
  ;
EndProcedure

Procedure exporticonimage(w.i=128)
  Protected file.s, icon.s, r.i, t.s, h.i, v.s
  ;
  ; *** save or copy image and icon files
  ;
  icon = Trim(GetGadgetText(#g_icon_name))
  If icon = ""
    icon = Trim(GetGadgetText(#g_executable_name))
  EndIf
  file = x_getnamepart(icon)
  If file = ""
    file = x_getnamepart(Trim(GetGadgetText(#g_executable_name)))
  EndIf
  If exportpath = ""
    file = "~programfolder~"+file
  Else
    file = exportpath+file
  EndIf
  file = GetPathPart(file)+x_getnamepart(file)
  file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
  ;
  r = #PB_MessageRequester_Yes
  ;
  If x_existx(file+".jpg") Or x_existx(file+".ico") Or x_existx(file+".bmp")
    t = "One or more files already exist. Overwrite?"+#CRLF$
    If x_exist(file+".jpg")
      t = t+#CRLF$
      If Len(file) > 50
        t = t+"..."+Right(file,50)+".jpg"
      Else
        t = t+file+".jpg"
      EndIf
    EndIf
    If x_existx(file+".ico")
      t = t+#CRLF$
      If Len(file) > 50
        t = t+"..."+Right(file,50)+".ico"
      Else
        t = t+file+".ico"
      EndIf
    EndIf
    If x_existx(file+".bmp")
      t = t+#CRLF$
      If Len(file) > 50
        t = t+"..."+Right(file,50)+".bmp"
      Else
        t = t+file+".bmp"
      EndIf
    EndIf
    If x_existx(file+".png")
      t = t+#CRLF$
      If Len(file) > 50
        t = t+"..."+Right(file,50)+".png"
      Else
        t = t+file+".png"
      EndIf
    EndIf
    r = MessageRequester("File already exists",t,#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning)
  EndIf
  ;
  If r = #PB_MessageRequester_Yes
    ;
    ; create the image
    ;
    CreateImage(#i_temp5,w,w)
    h=StartDrawing(ImageOutput(#i_temp5))
      DrawingMode(#PB_2DDrawing_Default)
      Box(0,0,w,w,$FFFFFF)
      drawiconfile(icon,h,0,0,w)
    StopDrawing()
    ;
    ; code below copies files where possible, unless they are very large in which case they are resized
    ; if the destination is the same is the source it is not replaced
    ;
    If LCase(icon) = LCase(file+".jpg")
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
      saveicon(#i_temp5,file+".ico")
    ElseIf LCase(icon) = LCase(file+".ico")
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
    ElseIf LCase(icon) = LCase(file+".bmp")
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
      saveicon(#i_temp5,file+".ico")
    ElseIf LCase(icon) = LCase(file+".png")
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      saveicon(#i_temp5,file+".ico")
    ElseIf LCase(GetExtensionPart(icon)) = "jpg"
      If FileSize(file+".jpg") > 25000
        SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      Else
        CopyFile(icon,file+".jpg")
      EndIf
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      saveicon(#i_temp5,file+".ico")
    ElseIf LCase(GetExtensionPart(icon)) = "png"
      If FileSize(file+".png") > 50000
        SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_JPEG,10)
      Else
        CopyFile(icon,file+".png")
      EndIf
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      saveicon(#i_temp5,file+".ico")
    ElseIf LCase(GetExtensionPart(icon)) = "bmp"
      If FileSize(file+".bmp") > 100000
        SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      Else
        CopyFile(icon,file+".bmp")
      EndIf
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
      saveicon(#i_temp5,file+".ico")
    ElseIf LCase(GetExtensionPart(icon)) = "ico"
      If CopyFile(icon,file+".ico") = 0
        saveicon(#i_temp5,file+".ico")
      EndIf
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
    Else
      SaveImage(#i_temp5,file+".jpg",#PB_ImagePlugin_JPEG,10)
      SaveImage(#i_temp5,file+".bmp",#PB_ImagePlugin_BMP)
      SaveImage(#i_temp5,file+".png",#PB_ImagePlugin_PNG)
      saveicon(#i_temp5,file+".ico")
    EndIf
    ;
    exportpath = GetPathPart(file)
    ;
  EndIf
EndProcedure

Procedure buildshortcutpanel()
  Protected x.i, y.i, n.i, mode.i, rows.i, columns.i, icon_w.i, icon_h.i, space.i, line_h.i, xx.i, yy.i, file.s, h.i, ff.i, font_h.i
  ;
  ; draw shortcutpanel
  ;
  icon_w = 32                         ; icon width
  icon_h = 32                         ; icon height
  space = 4                           ; space around icons
  line_h = 16                         ; linesize excluding space
  font_h = line_h*6/9                 ; font size
  ;
  mode = 1
  ;
  UseGadgetList(w_shortcutpanel_h)
  LoadFont(2,"Calibri",font_h,#PB_Font_HighQuality)
  With shortcut()
    ;
    n = ListSize(shortcut())-2        ; ignore the 2 default top entries autorun and separator
    ;
    ; process list and prep hitboxes
    ;
    If \image_high > 0
      FreeImage(\image_high)
    EndIf
    If \image_low > 0
      FreeImage(\image_low)
    EndIf
    ;
    Select mode
        Case 0
          ;
          ; *** auto - not yet implemented
          ;
          columns = Round(Sqr(n),#PB_Round_Up)
          rows = Round(n/columns,#PB_Round_Up)
          shortcutpanel_width = columns*(icon_w+space+space)
          shortcutpanel_height = rows*(icon_h+space+space)
          ;
        Case 1
          ;
          ; *** list
          ;
          shortcutpanel_width = space+40*8+space
          xx = 0
          yy = 0
          SelectElement(shortcut(),1)
          While NextElement(shortcut())
            If \type = #shortcut_separator
              ;
              ; separator line
              ;
              \x = xx+1
              \y = yy+1
              \w = shortcutpanel_width
              \h = space*2+2
              yy = yy+\h
              \image_high = CreateImage(#PB_Any,\w,\h)
              h=StartDrawing(ImageOutput(\image_high))
                DrawingMode(#PB_2DDrawing_Default)
                Box(0,0,\w,\h,$E0E0E0)
                LineXY(space*2,\h/2,\w-space*2,\h/2,$C0C0C0)
              StopDrawing()
              \image_low = CreateImage(#PB_Any,\w,\h)
              h=StartDrawing(ImageOutput(\image_low))
                DrawingMode(#PB_2DDrawing_Default)
                Box(0,0,\w,\h,$FFFFFF)
                LineXY(space*2,\h/2,\w-space*2,\h/2,$D0D0D0)
              StopDrawing()
              ;
            ElseIf \type = #shortcut_shortcut Or \type = #shortcut_wallpaper
              ;
              ; entry
              ;
              \x = xx+1
              \y = yy+1
              \w = shortcutpanel_width
              \h = Line_h+space+space
              yy = yy+\h
              ;
              ; get the right file for the icon
              ;
              If \type = #shortcut_wallpaper
                file = "~wallx~"
              ElseIf \type = #shortcut_separator
                file = "~separator~"
              ElseIf LCase(\name) = "wallx" And \executable = ""
                file = "~wallx~"
              Else
                file = \icon
                If file = ""
                  file = \executable
                EndIf
                file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
                file = Trim(LCase(file))
              EndIf
              ;
              ; create high image
              ;
              \image_high = CreateImage(#PB_Any,\w,\h)
              h=StartDrawing(ImageOutput(\image_high))
                DrawingFont(FontID(2))
                DrawingMode(#PB_2DDrawing_Default)
                Box(0,0,\w,\h,$E0E0E0)
                DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
                DrawText(line_h+space*3,space,\name,$000000)
                drawiconfile(file,h,space/2,space/2,line_h+space)
              StopDrawing()
              ;
              ; create low image
              ;
              \image_low = CreateImage(#PB_Any,\w,\h)
              h=StartDrawing(ImageOutput(\image_low))
                DrawingFont(FontID(2))
                DrawingMode(#PB_2DDrawing_Default)
                Box(0,0,\w,\h,$FFFFFF)
                DrawingMode(#PB_2DDrawing_Default|#PB_2DDrawing_Transparent)
                DrawText(line_h+space*3,space,\name,$000000)
                drawiconfile(file,h,Space,space,line_h)
              StopDrawing()
              ;
            EndIf
            shortcutpanel_height = yy+2
          Wend
          shortcutpanel_width = shortcutpanel_width+2
          ;
        Default
          ;
          ; *** grouped
          ;
    EndSelect
    ;
    ; create output
    ;
    ResizeWindow(#w_shortcutpanel_nr,#PB_Ignore,#PB_Ignore,shortcutpanel_width,shortcutpanel_height)
    CanvasGadget(#g_shortcutpanel,0,0,shortcutpanel_width,shortcutpanel_height)
    StartDrawing(CanvasOutput(#g_shortcutpanel))
      DrawingMode(#PB_2DDrawing_Default)
      Box(0,0,shortcutpanel_width,shortcutpanel_height,$707070)
      SelectElement(shortcut(),1)
      While NextElement(shortcut())
        DrawImage(ImageID(\image_low),\x,\y)
      Wend
    StopDrawing()
    ;
  EndWith
  FreeFont(2)
  ;
EndProcedure

Procedure updatethings(panel.i)
  Protected p.i, h.i, w.i, executable.s, icon.s, parameters.s, qqq.i
  ;
  ; hide irrelevant buttons, update several fields
  ;
  ; in:  0 - wallpaper tab
  ;      1 - shortcut tab
  ;     -1 - don't change
  ;
  qqq = GetGadgetState(#g_shortcut)
  p = GetGadgetState(#g_panel)
  If panel = -1
    panel = p
  EndIf
  ;
  ; show requested panel
  ;
  If p <> panel
    SetGadgetState(#g_panel,panel)
  EndIf
  ;
  ; block remove and replace on buttons autorun entry
  ;
  If qqq <= 1
    HideGadget(#g_removeshortcut,1)
    HideGadget(#g_replaceshortcut,1)
  Else
    HideGadget(#g_removeshortcut,0)
    HideGadget(#g_replaceshortcut,0)
  EndIf
  ;
  If panel = 0
    ;
    ; wallpaper tab is up front, hide irrelevant buttons and update fields where required
    ;
    ; only show wallpaper butotns
    ;
    HideGadget(#g_autorun_led,0)
    HideGadget(#g_autorun_set,0)
    HideGadget(#g_autorun_clear,0)
    HideGadget(#g_editbatch,1)
    HideGadget(#g_runprogram,1)
    HideGadget(#g_exporticonimage,1)
    ;
    ; show if autorun has been set, update fields
    ;
    If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
      SetGadgetState(#g_autorun_led,ImageID(#i_led_green))
    Else
      SetGadgetState(#g_autorun_led,ImageID(#i_led_white))
    EndIf
    ;
    SelectElement(shortcut(),#default_shortcut_autorun)
    SetGadgetItemText(#g_shortcut,#default_shortcut_autorun,shortcut()\name)
    ;
  ElseIf panel = 1
    ;
    ; shortcut tab is up front, hide irrelevant buttons and update fields where required
    ;
    ; prep
    ;
    executable = GetGadgetText(#g_executable_name)
    parameters = GetGadgetText(#g_parameters)
    ;
    ; update command line
    ;
    If FindString(executable," ") > 0
      executable = #DQUOTE$+executable+#DQUOTE$
    EndIf
    If FindString(parameters," ") > 0
      parameters = #DQUOTE$+parameters+#DQUOTE$
    EndIf
    SetGadgetText(#g_shortcutcommand,executable+" "+parameters)
    ;
    ; update exportpath and size
    ;
    exportpath = GetGadgetText(#g_exportpath_name)
    exportsize = Int(x_limit(Val(GetGadgetText(#g_exportsize))+8,16,128)/16)*16
    SetGadgetText(#g_exportsize,Str(exportsize))
    ;
    ; draw the icon file
    ;
    If LCase(GetGadgetText(#g_shortcutname)) = "wallx" And executable = ""
      icon = ProgramFilename()
    Else
      icon = GetGadgetText(#g_icon_name)
      If icon = ""
        icon = executable
      EndIf
      icon = ReplaceString(icon,"~programfolder~",GetPathPart(ProgramFilename()))
      icon = Trim(LCase(icon))
    EndIf
    w = 56
    CreateImage(#i_iconbutton,w,w)
    h=StartDrawing(ImageOutput(#i_iconbutton))
      Box(0,0,w,w,$FFFFFF)
      drawiconfile(icon,h,0,0,w)
    StopDrawing()
    SetGadgetAttribute(#g_icon_image,#PB_Button_Image,ImageID(#i_iconbutton))
    ;
    ; hide save button if there is no icon image to save
    ;
    If icon = ""
      HideGadget(#g_exporticonimage,1)
    Else
      HideGadget(#g_exporticonimage,0)
    EndIf
    ;
    ; only show shortcut buttons
    ;
    HideGadget(#g_autorun_led,1)
    HideGadget(#g_autorun_set,1)
    HideGadget(#g_autorun_clear,1)
    HideGadget(#g_runprogram,0)
    ;
    ; hide execute button if the entry can't be run
    ;
    If executable > ""
      HideGadget(#g_runprogram,0)
    Else
      HideGadget(#g_runprogram,1)
    EndIf
    ;
    ; hide batch-edit button if it isn't a batch file
    ;
    If x_existx(executable) And LCase(Right(executable,4)) = ".bat"
      HideGadget(#g_editbatch,0)
    Else
      HideGadget(#g_editbatch,1)
    EndIf
    ;
  EndIf
  ;
EndProcedure

Procedure readautorun()
  Protected n.i, p.s
  ;
  ; read eventual autorun settings from registry
  ;
  SelectElement(shortcut(),#default_shortcut_autorun)
  If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
    n = Len(x_commandfield(x_registry_s,1,#False))
    ;
    ; commandline = Trim(Mid(x_registry_s,n+1))
    ; shortcut()\parameters = commandline
    ;
    p = Trim(Mid(x_registry_s,n+1))
    shortcut()\parameters = p
  EndIf
EndProcedure

Procedure showshortcutdata(n)
  ;
  ; updates all fields on the panel to reflect shortcut 'n'
  ;
  With shortcut()
    SetGadgetState(#g_shortcut,n)
    SelectElement(shortcut(),n)
    Select shortcut()\type
        Case #shortcut_wallpaper
          If n = #default_shortcut_autorun
            readautorun()
          EndIf
          SetGadgetText(#g_wallpapername,\name)
          SetGadgetText(#g_commandline,\parameters)
          commandline = \parameters
          commandlinetogui()
          updatethings(0)
        Case #shortcut_separator, #shortcut_shortcut
          SetGadgetText(#g_shortcutname,\name)
          SetGadgetText(#g_executable_name,\executable)
          SetGadgetText(#g_parameters,\parameters)
          SetGadgetText(#g_path_name,\path)
          SetGadgetText(#g_icon_name,\icon)
          updatethings(1)
        Default
    EndSelect
  EndWith
  ;
EndProcedure

Procedure loadconfig()
  Protected n.i, nn.i, t.s, file.s, v.s, x.i, y.i
  ;
  ; *** load and place default shortcuts in combobox, build shortcut panel
  ;
  With shortcut()
    ;
    ; Default shortcuts (first four)
    ;
    ClearGadgetItems(#g_shortcut)
    ClearList(shortcut())
    ClearList(comment())
    ;
    AddElement(shortcut())
    \name = "Autorun"
    \type = #shortcut_wallpaper
    AddGadgetItem(#g_shortcut,#default_shortcut_autorun,\name)
    readautorun()
    AddElement(shortcut())
    \name = "------"
    \type = #shortcut_separator
    AddGadgetItem(#g_shortcut,#default_shortcut_separator,\name)
    ;
    ; load shortcuts
    ;
    file = GetPathPart(ProgramFilename())+"wallx.cfg"
    If x_existx(file)
      If ReadFile(1,file) > 0
        shortcuts = ""
        While Not Eof(1)
          shortcuts = shortcuts+ReadString(1,#PB_Ascii)+#CRLF$
        Wend
        CloseFile(1)
      EndIf
    Else
      shortcuts = x_peeks(p_default_shortcuts,-1,#PB_Ascii)
    EndIf
    ;
    n = CountString(shortcuts,#CRLF$)
    If n > 0 And n < 200
      For nn = 1 To n+1
        t = Trim(StringField(shortcuts,nn,#CRLF$))
        If Left(t,1) = ";"
          AddElement(comment())                                                ; comment
          comment() = t
        ElseIf t > "" And t <> "***"
          If Left(t,5) = "-----"                                               ; separator
            AddElement(shortcut())
            \type = #shortcut_separator
            \name = "------"
            \executable = ""
            \parameters = ""
            \path = ""
            \icon = ""
            AddGadgetItem(#g_shortcut,-1,\name)
          ElseIf FindString(t,"===") > 0                                       ; setting
            v = Trim(StringField(t,1,"==="))
            t = Trim(StringField(t,2,"==="))
            Select v
                Case "exportpath"
                  exportpath = t
                  SetGadgetText(#g_exportpath_name,exportpath)
                Case "exportsize"
                  exportsize = Int(x_limit(Val(t)+8,16,128)/16)*16
                  SetGadgetText(#g_exportsize,Str(exportsize))
                Default
            EndSelect
          ElseIf FindString(t,"==") > 0                                        ; shortcut
            AddElement(shortcut())
            \type = #shortcut_shortcut
            \name = Trim(StringField(t,1,"=="))
            t = StringField(t,2,"==")
            \executable = Trim(StringField(t,1,"~~"))
            \parameters = Trim(StringField(t,2,"~~"))
            \path = Trim(StringField(t,3,"~~"))
            \icon = Trim(StringField(t,4,"~~"))
            AddGadgetItem(#g_shortcut,-1,\name)
          ElseIf FindString(t,"=") > 0                                         ; wallpaper
            AddElement(shortcut())
            \type = #shortcut_wallpaper
            \name = Trim(StringField(t,1,"="))
            \executable = ""
            \parameters = Trim(StringField(t,2,"="))
            \path = ""
            \icon = ""
            AddGadgetItem(#g_shortcut,-1,\name)
          ElseIf LCase(t) = "wallx"                                            ; special - direct shortcut to wallx
            AddElement(shortcut())
            \type = #shortcut_shortcut
            \name = "WallX"
            \executable = ""
            \parameters = ""
            \path = ""
            \icon = ""
            AddGadgetItem(#g_shortcut,-1,\name)
          Else                                                                 ; anything else is thrown away
          EndIf
        EndIf
      Next nn
    EndIf
    ;
    ; make sure something is in the list
    ;
    If ListSize(shortcut()) = 0
      AddElement(shortcut())
      \type = #shortcut_shortcut
      \name = "WallX"
      \executable = ""
      \parameters = ""
      \path = ""
      \icon = ""
      AddGadgetItem(#g_shortcut,-1,\name)
    EndIf
    ;
    SetGadgetText(#g_wallpapername,\name)
    SetGadgetText(#g_commandline,\parameters)
    commandlinetogui()
    SetGadgetState(#g_shortcut,#default_shortcut_autorun)
    SetGadgetState(#g_panel,0)
    ;
  EndWith
  ;
EndProcedure

Procedure saveconfig()
  Protected file.s, x.i, tab.i, n.i
  ;
  ; *** save shortcuts to wallx.cfg file
  ;
  exportpath = GetGadgetText(#g_exportpath_name)
  exportsize = Int(x_limit(Val(GetGadgetText(#g_exportsize))+8,16,128)/16)*16
  SetGadgetText(#g_exportsize,Str(exportsize))
  ;
  file = configfile
  x = #PB_MessageRequester_Yes
  If Not x_exist(file)
    x = MessageRequester("WallX - Create config file?","This will create the file: "+#CRLF$+#CRLF$+file+#CRLF$+#CRLF$+"WallX needs this file to customise shortcuts. Continue?",#PB_MessageRequester_YesNo|#PB_MessageRequester_Warning)
  EndIf
  If x = #PB_MessageRequester_Yes
    x = 0
    n = 0
    While n < 5
      x = CreateFile(1,file,#PB_Ascii)
      If x = 0
        n = n+1
        Delay(512)
      Else
        n = 5
      EndIf
    Wend
    If x > 0
      With shortcut()
        ResetList(comment())
        While NextElement(comment())
          WriteString(1,comment()+#CRLF$)
        Wend
        ;
        tab = 70
        ;
        WriteString(1,#CRLF$)
        WriteString(1,LSet("exportpath",tab)+"     ===     "+exportpath+#CRLF$)
        WriteString(1,LSet("exportsize",tab)+"     ===     "+exportsize+#CRLF$)
        WriteString(1,#CRLF$)
        ResetList(shortcut())
        NextElement(shortcut())
        NextElement(shortcut())
        While NextElement(shortcut())
          Select \type
              Case #shortcut_separator
                WriteString(1,"------"+#CRLF$)
              Case #shortcut_shortcut
                WriteString(1,LSet(\name,tab)+"     ==      "+\executable+" ~~ "+\parameters+" ~~ "+\path+" ~~ "+\icon+#CRLF$)
              Case #shortcut_wallpaper
                WriteString(1,LSet(\name,tab)+"     =       "+\parameters+#CRLF$)
              Default
          EndSelect
        Wend
        WriteString(1,#CRLF$)
      EndWith
      CloseFile(1)
    EndIf
  EndIf
  ;
  configsize = FileSize(configfile)
  configdate = GetFileDate(configfile,#PB_Date_Modified)
  ;
EndProcedure

Procedure main()
  Protected n.i, t.s, file.s, nn.i, f.i, g.i, x.i, y.i, h.i, ww.i, hh.i, tt.s, ttt.s
  Protected wall_current.s, kill_countdown.i, t_delay.i
  Protected change.i, apply.i, k.s, help.s
  Protected lastinputinfo.LASTINPUTINFO
  Protected old_commandline.s, command.s, parameter.s
  Protected change_counter, monitor.i, old_command.s
  Protected target.s, link.s, icon.s
  Protected exit.i
  Protected parameters.s, working.s
  Protected hitbox.i, hitbox_old.i, r.RECT, tb_height.i
  Protected rearrange.i, sc_old.i, sc_new.i, sc_tmp.i
  ;
  lastinputinfo\cbSize = SizeOf(lastinputinfo)
  ;
  ; main loop
  ;
  ; commands / parameters can come in five ways
  ;
  ; 1. when run from within the ide
  ; 2. from the command line
  ; 3. from a file wallx.cmd
  ; 4. from an autorun entry
  ; 5. there were none so use default and show gui
  ;
  command_n = 0
  If #codecaddy_compilerun
    ;
    ; 1. from within the IDE
    ;
    ; set up command_test.s for quick testing from withing the IDE
    ; use '' instead of " here, that's easier than using #DQUOTE$ all the time :-)
    ;
    commandline = ""
    ; commandline = "help"
    ; commandline = "dotmark ''TEST''"
    ; commandline = "pink mark XPS710 save ~programfolder~"
    ; commandline = "base keep"
    ; commandline = "basemark ''VISTA64 SP3'' keep resident"
    ; commandline = "blue dotmark test"
    ; commandline = "delay 2 base fade text ''BASE IMAGE | TEST | NOT FOR REGULAR USE | ~host~ ~ip~ ''"
    ; commandline = "basemark TEST resident"
    ; commandline = "monitor 0 red monitor 1 blue text ''~desktop~ ~timestamp~'' monitor all drain"
    ; commandline = "monitor 0 red big ~desktop~ dots monitor 1 blue big ~desktop~ fade"
    ; commandline = "blue big ~desktop~ dots text ''TEST | ~host~ ~ip~ '' fade"
    ; commandline = "base blue fade dots"
    ; commandline = "traffic text test fade"
    ; commandline = "help"
    ; commandline = "load c:\software\wallpaper\an_air.jpg"
    ; commandline = "load c:\software\wallpapers\2h_bamboo.jpg transparent big ~ip~ text ''TEST | ~host~ ~ip~ ''"
    ; commandline = "load c:\googledrive\wallpapers\2h_mountainlake.jpg dots transparent big ~desktop~ text '' MONITOR ~desktop~ | ~timestamp~'' fade "
    ; commandline = "monitor 0 load c:\software\wallpapers\an_evangelion.jpg monitor 1 load c:\software\wallpapers\an_eureka7_1.jpg monitor all transparent big ~ip~ dots text ''XPS710 | ~host~ ~ip~ '' fade"
    ; commandline = "random c:\software\wallpaper"
    ; commandline = "silent random c:\software\wallpaper transparent mark xps710"
    ; commandline = "traffic desktop 0 red desktop 1 blue desktop all dotmark ~monitor~ save c:\software\wallpaper\test.bmp"
    ; commandline = "traffic drain mark ~monitor~"
    ; commandline = "traffic distort 40 expand 200 random c:\software\wallpaper transparent big ~monitor~ mark save c:\software\wallpaper\test.bmp"
    ; commandline = "dotmark ~USER~ resident"
    ; commandline = "text ''~ip~|~ipall~''"
    ; commandline = "ipallmark test keep resident"
    ; commandline = "traffic reverse drain dotmark ~USER~ keep"
    ; commandline = "random g:\wallpapers renew 2 nouser 10 resident"
    ; commandline = "mark test"
    ; commandline = "transparent mark MEDIA4"
    ; commandline = "big ~ip~ fade transparent text ''ADMIN|~host~ ~ip~'' fade"
    ; commandline = "distort 10 expand 100 random g:\wallpapers\ transparent mark ''DEV2'' renew 1 nouser 1 pairs 99 resident"
    ; commandline = "gui"
    ; commandline = "get d:\test.bmp"
    ; commandline = "set d:\test.bmp gui"
    ; commandline = "mark keep save d:\test.bmp"
    ; commandline = "monitor all load c:\googledrive\wallpapers\pk_cover_kindskisslight.jpg fade distort 15 expand 100 keep"
    ; commandline = "random c:\googledrive\wallpapers distort 20 expand 150 keep nouser 1 renew 1 resident"
    ; commandline = "monitor 1 red monitor 2 green monitor 3 blue monitor 4 yellow random c:\googledrive\wallpapers transparent monitor all big ~monitor~ fade markup keep"
    ; commandline = "red round keep gui"
    ;
    commandline = Trim(ReplaceString(commandline,"''",#DQUOTE$))
    command_n = x_commandcount(commandline)
    ;
  EndIf
  If command_n = 0
    ;
    ; 2. check for command line parameters
    ;
    command_n = CountProgramParameters()
    n = 0
    While n < command_n
      n = n+1
      t = ProgramParameter()
      If FindString(t," ") > 0
        commandline = commandline+" "+#DQUOTE$+t+#DQUOTE$+" "
      Else
        commandline = commandline+" "+t
      EndIf
    Wend
    commandline = Trim(commandline)
    command_n = x_commandcount(commandline)
    ;
  EndIf
  If command_n = 0
    ;
    ; 3. read configuration from wallx.cmd if one exists
    ;
    file = GetPathPart(ProgramFilename())+"wallx.cmd"
    If FileSize(file)>2
      ReadFile(1,file)
      While Not Eof(1)
        k = Trim(ReadString(1))
        If k > "" And Left(k,1) <> ";"
          commandline = commandline + k
        EndIf
      Wend
      CloseFile(1)
      commandline = Trim(commandline)
      command_n = x_commandcount(commandline)
    EndIf
    ;
  EndIf
  If command_n = 0
    ;
    ; 4. retrieve commandline from an autorun entry in the registry
    ;
    If x_registry_get(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX") = 0
      n = Len(x_commandfield(x_registry_s,1,#False))
      commandline = Trim(Mid(x_registry_s,n+1))+" gui"
      command_n = x_commandcount(commandline)
    EndIf
    ;
  EndIf
  If command_n = 0
    ;
    ; 5. there wasn't a commandline so use the default one (default commandline)
    ;
    commandline = "keep resident gui"
    ;
    ; corporate users might not like the default 'keep' option
    ;
    ;   If OSVersion() >= #PB_OS_Windows_Vista
    ;     commandline = commandline+" keep"
    ;   EndIf
    ;
    command_n = x_commandcount(commandline)
    ;
  EndIf
  ;
  ; expand combos and handle special one-shot cases
  ;
  old_command = ""
  t = ""
  n = 0
  While n < command_n
    n = n+1
    command = x_commandfield(commandline,n,#False)
    parameter = x_commandfield(commandline,n+1,#True)
    ;
    Select command
        Case "gui"
          ;
          gui = #True
          ;
        Case "help"
          ;
          x_littlehelp(" WallX "+#program_version+" - "+#program_copyright+" - "+FormatDate("%DD.%MM.%YYYY",#codecaddy_build_date)+" build "+Str(#codecaddy_build_nr)+" save "+Str(#codecaddy_save_nr),"",p_helptext,#PB_Ascii)
          commandline = ""
          command_n = 0
          t = ""
          ;
        Case "adminmark"
          ;
          ; my regular admin wallpaper
          ;
          t = t+" traffic darken big ~ip~ fade text "+#DQUOTE$+"ADMIN | ~host~ ~ip~"+#DQUOTE$
          ;
        Case "basemark"
          ;
          ; my regular base wallpaper
          ;
          t = t+" base fade text "+#DQUOTE$+" BASE IMAGE | "+parameter+" | NOT FOR REGULAR USE | ~host~ ~ip~"+#DQUOTE$
          n = n+1
          ;
        Case "highmark"
          ;
          ; companion to basemark / adminmark
          ;
          t = t+" big ~ip~ fade text "+#DQUOTE$+parameter+"| ~host~ ~ip~"+#DQUOTE$
          n = n+1
          ;
        Case "lowmark", "mark"
          ;
          ; typical use: on top of normal wallpapers
          ;
          t = t+" transparent big ~ip~ fade text "+#DQUOTE$+parameter+"| ~host~ ~ip~"+#DQUOTE$
          n = n+1
          ;
        Case "darkmark"
          ;
          ; as highmark but more contrast
          ;
          t = t+" fade big ~ip~ darken text "+#DQUOTE$+parameter+"| ~host~ ~ip~"+#DQUOTE$+" darken darken"
          n = n+1
          ;
        Case "dotmark"
          ;
          ; my default settings for images showing one ip address
          ;
          t = t+" big ~ip~ dots text "+#DQUOTE$+parameter+"| ~host~ ~ip~ "+#DQUOTE$+" fade"
          n = n+1
          ;
        Case "ipallmark"
          ;
          ; my regular wallpaper for images showing all ip addresses
          ;
          t = t+" big ~ip~ dots text "+#DQUOTE$+parameter+"| ~host~ ~ipall~ "+#DQUOTE$+" fade"
          n = n+1
          ;
        Case "delay"
          ;
          ; manual one shot delay (eats up windows messages though)
          ;
          t_delay = GetTickCount_()+Val(parameter)*1000
          While GetTickCount_() < t_delay
            Delay(128)
          Wend
          n = n+1
          ;
        Case "get"
          ;
          ; retrieve name / path / file of current wallpaper
          ;
          file = Space(#MAX_PATH+2)
          SystemParametersInfo_(#SPI_GETDESKWALLPAPER,Len(file),@file,0)
          If parameter = "name"
            MessageRequester("WallX "+#program_version,"Current wallpaper is "+#CRLF$+#CRLF$+file,#PB_MessageRequester_Ok)
          ElseIf parameter > ""
            If CopyFile(file,parameter) = 0 And silent = #False
              MessageRequester("WallX "+#program_version,"Could not copy "+#CRLF$+#CRLF$+file+#CRLF$+#CRLF$+"to"+#CRLF$+#CRLF$+parameter,#PB_MessageRequester_Ok|#MB_ICONERROR)
            EndIf
          EndIf
          n = n+1
          ;
        Case "set"
          ;
          ; directly set wallpaper and switch tiling off
          ;
          If x_exist(parameter)
            x_registry_set(#HKEY_CURRENT_USER,"Control Panel\Desktop","TileWallPaper",#REG_SZ,0,"0",0)
            SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@parameter,#SPIF_UPDATEINIFILE)
            SystemParametersInfo_(#SPI_SETDESKWALLPAPER,0,@parameter,#SPIF_SENDWININICHANGE)
          Else
            MessageRequester("WallX "+#program_version,"Could not find "+#CRLF$+#CRLF$+parameter,#PB_MessageRequester_Ok|#MB_ICONERROR)
          EndIf
          n = n+1
          ;
        Default
          ;
          If old_command <> "save" And old_command <> "load" And old_command <> "span" And old_command <> "fit" And Len(command)> 4 And ( LCase(Right(command,4)) = ".jpg" Or LCase(Right(command,4)) = ".bmp" Or LCase(Right(command,4)) = ".png" )
            ;
            ; v1.70x now allows direct referencing to files, as happens in drag and drop, or for those too lazy to type 'load'
            ; multiple images are spread over all monitors
            ;
            monitor = monitor+1
            If monitor = 1
              t = t+" load "+#DQUOTE$+command+#DQUOTE$+" fade"
            Else
              t = t+" monitor "+Str(monitor)+" load "+#DQUOTE$+command+#DQUOTE$+" fade"
            EndIf
            ;
          Else
            ;
            ; must be some other command that doesn't need processing (yet)
            ;
            t = t+" "+command
            old_command = command
            ;
          EndIf
    EndSelect
    ;
  Wend
  commandline = Trim(t)
  command_n = x_commandcount(commandline)
  ;
  ; prepare ip adress table
  ;
  checkipadresses()
  checkipadresses()
  ;
  ; find desktop dimensions
  ;
  checkdesktops()
  ;
  ; executecommands any commands
  ;
  If gui = #True Or stayresident = #True
    apply = #True
  Else
    executecommands()
  EndIf
  ;
  ; prep the shortcutpanel (invisible)
  ;
  w_shortcutpanel_h = OpenWindow(#w_shortcutpanel_nr,10,10,10,10,"WallX",#PB_Window_BorderLess|#PB_Window_Invisible) ; ,WindowID(#w_main_nr))
  SetWindowLong_(w_shortcutpanel_h,#GWL_EXSTYLE,GetWindowLong_(w_shortcutpanel_h,#GWL_EXSTYLE)|#WS_EX_TOOLWINDOW)
  ;
  ; build up the GUI window (invisible)
  ;
  ww = 530
  hh = 499
  w_main_h = OpenWindow(#w_main_nr,10,10,ww,hh,"WallX "+#program_version+" - "+#program_copyright,#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MinimizeGadget|#PB_Window_Invisible)
  EnableWindowDrop(#w_main_nr,#PB_Drop_Files,#PB_Drag_Copy)
  ;
  ; return to the main window
  ;
  UseGadgetList(w_main_h)
  ;
  x = 15
  y = 18
  TextGadget(#g_shortcut_t,x,y,60,16,"Shortcut")
  ComboBoxGadget(#g_shortcut,x+90,y-3,300,22)
  ;
  x = 7
  y = 50
  PanelGadget(#g_panel,x,y,ww-12,hh-47-y)
    ;
    ;  wallpapers tab
    ;
    AddGadgetItem(#g_panel,0,"Wallpaper")
    ;
    x = 20
    y = 3
    h = 307
    FrameGadget(#g_wallpaperframe,7,y,496,h,"")
    ;
    y = y+18
    TextGadget(#g_wallpapername_t,x,y+4,100,16,"0. Name")
    StringGadget(#g_wallpapername,x+100,y,369,19,"")
    y = y+29
    TextGadget(#g_wallpaper_t,x,y+4,100,16,"1. Wallpaper")
    ComboBoxGadget(#g_wallpaper,x+100,y,125,22)
    AddGadgetItem(#g_wallpaper,#g_wallpaper__randomcolour,"Random colour")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__loadfile,"Load file")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__spanfile,"Span file")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__fitfile,"Fit file")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__red,"Red")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__green,"Green")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__blue,"Blue")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__yellow,"Yellow")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__cyan,"Cyan")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__lime,"Lime")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__orange,"Orange")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__pink,"Pink")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__black,"Black")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__grey,"Grey")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__white,"White")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__traffic,"Traffic")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__base,"Base")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__frompath,"Random from folder")
    AddGadgetItem(#g_wallpaper,#g_wallpaper__programfolder,"Random from program folder")
    TextGadget(#g_wallpaper_file_t,x+235,y+2,60,19,"File")
    StringGadget(#g_wallpaper_file,x+260,y,188,19,"")
    EnableGadgetDrop(#g_wallpaper_file,#PB_Drop_Files,#PB_Drag_Copy)
    GadgetToolTip(#g_wallpaper_file,"Image file or path")
    ButtonGadget(#g_wallpaper_browse,x+450,y,20,19,"...")
    y = y+29
    TextGadget(#g_effect1_t,x,y+2,100,16,"2. Effect")
    CheckBoxGadget(#g_effect1_dots,x+100,y+2,60,16,"Dots")
    CheckBoxGadget(#g_effect1_fade,x+160,y+2,60,16,"Fade")
    CheckBoxGadget(#g_effect1_darken,x+220,y+2,60,16,"Darken")
    CheckBoxGadget(#g_effect1_drain,x+290,y+2,60,16,"Drain")
    CheckBoxGadget(#g_effect1_blur,x+350,y+2,60,16,"Blur")
    CheckBoxGadget(#g_effect1_invert,x+410,y+2,60,16,"Invert")
    y = y+29
    TextGadget(#g_big_text_t,x,y+2,100,16,"3. Big text")
    StringGadget(#g_big_text,x+100,y,65,19,"")
    GadgetToolTip(#g_big_text,"Large background text (1 to 3 characters)")
    CheckBoxGadget(#g_big_reverse,x+185,y+2,60,16,"Reverse")
    CheckBoxGadget(#g_big_transparent,x+260,y+2,80,16,"Transparent")
    y = y+29
    TextGadget(#g_effect2_t,x,y+2,100,16,"4. Effect")
    CheckBoxGadget(#g_effect2_dots,x+100,y+2,60,16,"Dots")
    CheckBoxGadget(#g_effect2_fade,x+160,y+2,60,16,"Fade")
    CheckBoxGadget(#g_effect2_darken,x+220,y+2,60,16,"Darken")
    CheckBoxGadget(#g_effect2_drain,x+290,y+2,60,16,"Drain")
    CheckBoxGadget(#g_effect2_blur,x+350,y+2,60,16,"Blur")
    CheckBoxGadget(#g_effect2_invert,x+410,y+2,60,16,"Invert")
    y = y+29
    TextGadget(#g_normal_text_t,x,y+2,100,16,"5. Normal text")
    StringGadget(#g_normal_text,x+100,y,200,19,"")
    GadgetToolTip(#g_normal_text,"Normal text (multiple lines | special codes ~host~ ~ip~ ~monitor~)")
    CheckBoxGadget(#g_normal_reverse,x+320,y+2,60,16,"Reverse")
    CheckBoxGadget(#g_normal_transparent,x+395,y+2,80,16,"Transparent")
    y = y+29
    TextGadget(#g_effect3_t,x,y+2,100,16,"6. Effect")
    CheckBoxGadget(#g_effect3_dots,x+100,y+2,60,16,"Dots")
    CheckBoxGadget(#g_effect3_fade,x+160,y+2,60,16,"Fade")
    CheckBoxGadget(#g_effect3_darken,x+220,y+2,60,16,"Darken")
    CheckBoxGadget(#g_effect3_drain,x+290,y+2,60,16,"Drain")
    CheckBoxGadget(#g_effect3_blur,x+350,y+2,60,16,"Blur")
    CheckBoxGadget(#g_effect3_invert,x+410,y+2,60,16,"Invert")
    ;
    y = y+29
    x = 20
    h = 40
    TextGadget(#g_effect4_t,x,y+2,100,16,"7. Effect")
    CheckBoxGadget(#g_effect4_round,x+100,y+2,60,16,"Round")
    CheckBoxGadget(#g_markup,x+165,y+2,80,16,"Markup")
    GadgetToolTip(#g_markup,"Add boundary and file information to the generated background")
    ;
    y = y+29
    TextGadget(#g_timeandplace_t,x,y+2,100,16,"8. Distort & Renew")
    TextGadget(#g_distort_t,x+100,y+2,50,16,"Distort")
    StringGadget(#g_distort,x+140,y,28,19,"")
    GadgetToolTip(#g_distort,"Maximal aspect distortion in % (default 15%)")
    TextGadget(#g_expand_t,x+180,y+2,50,16,"Expand")
    StringGadget(#g_expand,x+225,y,28,19,"")
    GadgetToolTip(#g_expand,"Maximal image resize in % (default 53%)")
    TextGadget(#g_renew_t,x+260,y+2,50,16,"Renew")
    StringGadget(#g_renew,x+300,y,38,19,"")
    GadgetToolTip(#g_renew,"Renew background time in seconds")
    TextGadget(#g_nouser_t,x+350,y+2,50,16,"Nouser")
    StringGadget(#g_nouser,x+395,y,38,19,"")
    GadgetToolTip(#g_nouser,"Only renew if user is away for n seconds (default 120)")
    ;
    y = y+29
    x = 20
    h = 40
    TextGadget(#g_system_t,x,y+2,100,16,"9. System")
    CheckBoxGadget(#g_keep,x+100,y+2,60,16,"Keep")
    GadgetToolTip(#g_keep,"Store wallpaper as local temp file and show upon reboot (may be required on some Windows platforms)")
    CheckBoxGadget(#g_resident,x+170,y+2,80,16,"Resident")
    GadgetToolTip(#g_resident,"Keep WallX running in the background so it can refresh wallpapers and detect screen or IP changes)")
    CheckBoxGadget(#g_pre10,x+255,y+2,60,16,"Pre10")
    GadgetToolTip(#g_pre10,"Use older mechanism for multi monitor wallpaper (pre Windows 10)")
    ;
    y = y+36
    h = 45
    TextGadget(#g_commandline_t,x,y,100,16,"Parameters")
    TextGadget(#g_commandline,x+100,y,374,h,"")
    ;
    ; shortscuts tab
    ;
    AddGadgetItem(#g_panel,1,"Shortcut")
    ;
    x = 20
    y = 3
    h = 164
    FrameGadget(#g_shortcutframe,7,y,496,h,"")
    ;
    y = y+18
    TextGadget(#g_shortcutname_t,x,y+4,100,16,"Name")
    StringGadget(#g_shortcutname,x+100,y,369,19,"")
    GadgetToolTip(#g_shortcutname_t,"Used when creating new presets")
    y = y+29
    TextGadget(#g_executable_t,x,y+2,100,19,"File")
    StringGadget(#g_executable_name,x+100,y,348,19,"")
    EnableGadgetDrop(#g_executable_name,#PB_Drop_Files,#PB_Drag_Copy)
    GadgetToolTip(#g_executable_name,"File to execute (.lnk .bat .exe)")
    ButtonGadget(#g_executable_browse,x+450,y,20,19,"...")
    y = y+29
    TextGadget(#g_parameters_t,x,y+2,100,19,"Parameters")
    StringGadget(#g_parameters,x+100,y,369,19,"")
    GadgetToolTip(#g_parameters,"Commandline parameters")
    y = y+29
    TextGadget(#g_path_t,x,y+2,100,19,"Path")
    StringGadget(#g_path_name,x+100,y,348,19,"")
    GadgetToolTip(#g_path_name,"Path")
    ButtonGadget(#g_path_browse,x+450,y,20,19,"...")
    ;
    y = y+29
    TextGadget(#g_icon_t,x,y+2,60,19,"Image")
    StringGadget(#g_icon_name,x+100,y,348,19,"")
    GadgetToolTip(#g_icon_name,"File to retrieve icon from (.ico .png .jpg .bmp .exe)")
    EnableGadgetDrop(#g_icon_name,#PB_Drop_Files,#PB_Drag_Copy)
    ButtonGadget(#g_icon_browse,x+450,y,20,19,"...")
    ;
    y = y+37
    TextGadget(#g_icon_image_t,x,y+9,100,16,"Image")
    ButtonImageGadget(#g_icon_image,x+100,y,64,64,0)
    EnableGadgetDrop(#g_icon_image,#PB_Drop_Files,#PB_Drag_Copy)
    y = y+72
    h = 45
    TextGadget(#g_shortcutcommand_t,x,y,100,16,"Command")
    TextGadget(#g_shortcutcommand,x+100,y,374,h,"")
    ;
    ; export section
    ;
    y = 291
    h = 77
    FrameGadget(#g_exportframe,7,y,496,h,"")
    ;
    y = y+18
    TextGadget(#g_exportpath_t,x,y+2,100,19,"Exportpath")
    StringGadget(#g_exportpath_name,x+100,y,348,19,"")
    EnableGadgetDrop(#g_exportpath_name,#PB_Drop_Files,#PB_Drag_Copy)
    GadgetToolTip(#g_exportpath_name,"Path to export icons and images to")
    ButtonGadget(#g_exportpath_browse,x+450,y,20,19,"...")
    y = y+29
    TextGadget(#g_exportsize_t,x+100,y+2,50,16,"Size")
    StringGadget(#g_exportsize,x+130,y,28,19,"")
    ;
    loadconfig()
    ;
  CloseGadgetList()
  ;
  ; bottom buttons (partially overlapping, which is handled by updatethings())
  ;
  y = hh-40
  x = ww-13*35-5
  ImageGadget(#g_autorun_led,x+12,y+9,16,16,ImageID(#i_led_white))
  ButtonImageGadget(#g_editbatch,x,y,32,32,ImageID(#i_notepad))
  GadgetToolTip(#g_editbatch,"Edit batch file")
  x = x+35
  ButtonImageGadget(#g_autorun_set,x,y,32,32,ImageID(#i_windows))
  GadgetToolTip(#g_autorun_set,"Set autorun entry in the registry")
  ButtonImageGadget(#g_exporticonimage,x,y,32,32,ImageID(#i_disk))
  GadgetToolTip(#g_exporticonimage,"Export icon and images")
  x = x+35
  ButtonImageGadget(#g_autorun_clear,x,y,32,32,ImageID(#i_windows_grey))
  GadgetToolTip(#g_autorun_clear,"Clear autorun entry in the registry")
  ButtonImageGadget(#g_runprogram,x,y,32,32,ImageID(#i_play_green))
  GadgetToolTip(#g_runprogram,"Execute")
  x = x+35
  ButtonImageGadget(#g_desktopshortcut,x,y,32,32,ImageID(#i_shortcut))
  GadgetToolTip(#g_desktopshortcut,"Create a shortcut on the desktop")
  x = x+35
  ButtonImageGadget(#g_copy,x,y,32,32,ImageID(#i_copy))
  GadgetToolTip(#g_copy,"Copy commandline to clipboard")
  x = x+35
  ImageGadget(#g_busy_led,x+12,y+9,16,16,ImageID(#i_led_white))
  x = x+35
  ButtonImageGadget(#g_refresh,x,y,32,32,ImageID(#i_eyes_2))
  GadgetToolTip(#g_refresh,"Refresh")
  x = x+35
  ButtonImageGadget(#g_addshortcut,x,y,32,32,ImageID(#i_plus))
  GadgetToolTip(#g_addshortcut,"Add shortcut")
  x = x+35
  ButtonImageGadget(#g_removeshortcut,x,y,32,32,ImageID(#i_minus))
  GadgetToolTip(#g_removeshortcut,"Remove shortcut")
  x = x+35
  ButtonImageGadget(#g_replaceshortcut,x,y,32,32,ImageID(#i_equal))
  GadgetToolTip(#g_replaceshortcut,"Replace shortcut")
  x = x+35
  ButtonImageGadget(#g_editshortcuts,x,y,32,32,ImageID(#i_bullets))
  GadgetToolTip(#g_editshortcuts,"Edit shortcuts")
  x = x+35
  ButtonImageGadget(#g_help,x,y,32,32,ImageID(#i_help))
  GadgetToolTip(#g_help,"Show documentation")
  x = x+35
  ButtonImageGadget(#g_exit,x,y,32,32,ImageID(#i_exit))
  GadgetToolTip(#g_exit,"Exit (no longer stay resident")
  ;
  ; show autorun entry, parse the commandline and fill appropriate gadgets
  ;
  SetGadgetState(#g_shortcut,0)
  SetGadgetText(#g_wallpapername,"Autorun")
  SetGadgetText(#g_commandline,commandline)
  commandlinetogui()
  ;
  SetActiveGadget(#g_shortcut)
  updatethings(0)
  buildshortcutpanel()
  ;
  If gui
    HideWindow(#w_main_nr,0)
  EndIf
  ;
  ; resident or gui
  ;
  If stayresident = #True Or gui = #True
    ;
    ; terminate all other instances by sending a kill message
    ; ignore any received kill messages received during the first 2 seconds (so wallx won't kill itself)
    ;
    PostMessage_(#HWND_BROADCAST,killmessage_nr,0,0)
    kill_countdown = GetTickCount_()+1*1000
    ;
    ; add trayicon
    ;
    AddSysTrayIcon(#g_systrayicon,WindowID(#w_main_nr),ImageID(#i_wallnut))
    SysTrayIconToolTip(#g_systrayicon,"WallX")
    ;
    exit = #False                           ; true to quit
    apply = #False                          ; true to force processing presets file, redraw screen by applying command line etc.
    change = #False                         ; true will trigger a guitocommandline() before doing an apply
    hitbox = -1                             ; used to detect mouse movement on canvasgadget for shortcutpanel
    hitbox_old = -1                         ; used to detect mouse movement on canvasgadget for shortcutpanel
    ;
    Repeat
      ;
      ; grab windows events
      ;
      ; variable delay, if there's a pending delay wait only a little, this way scrolling through the list keeps icons up to date but does not trigger a redraw
      ; how well this works might work on the speed of the machine wallx runs on... need to test this on different machines
      ;
      If apply
        event = WaitWindowEvent(100)
      ElseIf configtimer > 0
        event = WaitWindowEvent(250)
      Else
        event = WaitWindowEvent(1000)
      EndIf
      ;
      event_window = EventWindow()
      event_gadget = EventGadget()
      event_menu = EventMenu()
      event_type = EventType()
      ;
      ; first check windowevents, then if there are none (0) do other stuff
      ;
      If event <> 0
        ;
        ; windows events, user interaction
        ;
        Select event
            Case #PB_Event_CloseWindow
              ;
              ; exit
              ;
              If stayresident = #False
                exit = #True
              Else
                HideWindow(#w_main_nr,1)
                gui = #False
              EndIf
              ;
            Case #PB_Event_DeactivateWindow
              ;
              ; hide shortcuts panel if any window was deactivated
              ;
              HideWindow(#w_shortcutpanel_nr,1)
              ;
            Case killmessage_nr
              ;
              ; any kill messages received after kill_countdown will exit the program
              ;
              If GetTickCount_() > kill_countdown
                exit = #True
              EndIf
              ;
            Case #PB_Event_SysTray
              If Event_type = #PB_EventType_LeftClick Or event_type = #PB_EventType_RightClick
                ;
                ; show shortcuts panel
                ;
                r.RECT
                SystemParametersInfo_(#SPI_GETWORKAREA,0,@r,0)
                x = DesktopMouseX()-shortcutpanel_width/2
                y = x_min(DesktopMouseY()-shortcutpanel_height-2,r\bottom-r\top-shortcutpanel_height)
                ResizeWindow(#w_shortcutpanel_nr,x,y,#PB_Ignore,#PB_Ignore)
                HideWindow(#w_shortcutpanel_nr,0)
                SetActiveWindow(#w_shortcutpanel_nr)
                ShowWindow_(w_shortcutpanel_h,#SW_RESTORE)
                PostMessage_(#HWND_BROADCAST,#WM_SYSCOMMAND,#SC_HOTKEY,w_shortcutpanel_h)
                ;
              ElseIf event_type = #PB_EventType_LeftDoubleClick
                ;
                ; show main window
                ;
                HideWindow(#w_shortcutpanel_nr,1)
                HideWindow(#w_main_nr,0)
                SetActiveWindow(#w_main_nr)
                gui = #True
                ;
                ; what didn't work to get the window back on top:
                ;
                ;   SetActiveWindow(#w_main_nr)
                ;   SetWindowPos_(w_main_h,#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE|#SWP_SHOWWINDOW)
                ;
                ; both of the next two lines work (most of the time) by themselves, but hey, use 'm both :-)
                ;
                ShowWindow_(w_main_h,#SW_RESTORE)
                PostMessage_(#HWND_BROADCAST,#WM_SYSCOMMAND,#SC_HOTKEY,w_main_h)
                ;
              EndIf
              ;
            Case #PB_Event_WindowDrop
              ;
              ; dragging a file on the window will cause wallx to act depending on the type of file
              ;
              ; folder                 - random wallpaper from path
              ; .bmp .jpg .png         - load specified wallpaper
              ; .ico                   - set the icon for the shortcut
              ; .exe .url .bat .lnk .* - anything else it tries to create an entry for
              ;
              file = EventDropFiles()
              If file > ""
                t = Right(LCase(file),4)
                If FileSize(file) = -2                                                         ; someone dropped a folder, it's assumed to contain wallpapers
                  If Right(file,1) <> "\"
                    file = file+"\"
                  EndIf
                  SetGadgetState(#g_wallpaper,#g_wallpaper__frompath)
                  SetGadgetText(#g_wallpaper_file,file)
                  guitocommandline()
                  updatethings(0)
                  apply = #True
                ElseIf FileSize(file) > 0                                                      ; someone dropped a file
                  If t = ".bmp" Or t = ".jpg"                                                  ; it's a wallpaper
                    SetGadgetState(#g_wallpaper,#g_wallpaper__loadfile)
                    SetGadgetText(#g_wallpaper_file,file)
                    SetGadgetText(#g_wallpapername,x_chop(GetFilePart(file),0,4))
                    guitocommandline()
                    updatethings(0)
                    apply = #True
                  ElseIf t = ".ico" Or t = ".png"                                              ; it's an icon file
                    SetGadgetText(#g_icon_name,file)
                    updatethings(1)
                    apply = #True
                  ElseIf t = ".url"                                                            ; it's an url, either to a webpage or something like a stream app
                    SetGadgetText(#g_executable_name,file)
                    SetGadgetText(#g_parameters,"")
                    SetGadgetText(#g_path_name,"")
                    SetGadgetText(#g_icon_name,"")
                    If ReadFile(1,file)
                      While Not Eof(1)
                        t = ReadString(1)
                        tt = Trim(LCase(StringField(t,1,"=")))
                        ttt = Trim(StringField(t,2,"="))
                        If tt = "url"
                          SetGadgetText(#g_executable_name,ttt)
                        ElseIf tt = "iconfile"
                          SetGadgetText(#g_icon_name,ttt)
                        EndIf
                      Wend
                      CloseFile(1)
                      SetGadgetText(#g_shortcutname,x_chop(GetFilePart(file),0,4))
                      updatethings(1)
                      apply = #True
                    EndIf
                  Else
                    SetGadgetText(#g_shortcutname,"")
                    SetGadgetText(#g_parameters,"")
                    SetGadgetText(#g_path_name,"")
                    SetGadgetText(#g_icon_name,"")
                    Select t
                        Case ".lnk"                                                            ; a .lnk (shortcut) file
                          If targetfromlnk(file) > ""
                            SetGadgetText(#g_shortcutname,x_chop(GetFilePart(file),0,4))
                            SetGadgetText(#g_executable_name,targetfromlnk(file))
                            SetGadgetText(#g_parameters,parametersfromlnk(file))
                            SetGadgetText(#g_path_name,workingfolderfromlnk(file))
                            SetGadgetText(#g_icon_name,iconfromlnk(file))
                          Else
                            SetGadgetText(#g_shortcutname,GetFilePart(file))
                            SetGadgetText(#g_executable_name,file)
                          EndIf
                        Case ".exe"                                                            ; an executable
                          SetGadgetText(#g_shortcutname,x_chop(GetFilePart(file),0,4))
                          SetGadgetText(#g_executable_name,file)
                        Default                                                                ; anything else
                          SetGadgetText(#g_shortcutname,GetFilePart(file))
                          SetGadgetText(#g_executable_name,file)
                    EndSelect
                    updatethings(1)
                    apply = #True
                  EndIf
                EndIf
              EndIf
              ;
            Case #PB_Event_GadgetDrop
              ;
              file = EventDropFiles()
              t = Right(LCase(file),4)
              Select event_gadget
                  Case #g_wallpaper_file
                    If FileSize(file) = -2
                      SetGadgetState(#g_wallpaper,#g_wallpaper__frompath)
                      SetGadgetText(#g_wallpaper_file,file+"\")
                      guitocommandline()
                      apply = #True
                    ElseIf FileSize(file) > 0
                      If t = ".bmp" Or t = ".jpg" Or t = ".png"
                        SetGadgetState(#g_wallpaper,#g_wallpaper__loadfile)
                        SetGadgetText(#g_wallpaper_file,file)
                        guitocommandline()
                        apply = #True
                      EndIf
                    EndIf
                  Case #g_executable_name
                    SetGadgetText(#g_executable_name,file)
                    updatethings(1)
                    apply = #True
                  Case #g_icon_name, #g_icon_image
                    If t = ".ico" Or t = ".bmp" Or t = ".png" Or t = ".exe" Or t = ".jpg"
                      SetGadgetText(#g_icon_name,file)
                      updatethings(1)
                      apply = #True
                    EndIf
              EndSelect
              ;
            Case #PB_Event_Gadget
              ;
              ; a button etc. was pressed
              ;
              Select event_gadget
                  Case #g_panel
                    ;
                    ; hide / show buttons depending on active tab
                    ;
                    updatethings(GetGadgetState(#g_panel))
                    ;
                  Case #g_wallpaper_file, #g_big_text, #g_normal_text, #g_distort, #g_expand, #g_renew, #g_nouser
                    ;
                    ; string fields with values, will only be processed after 'refresh' has been pressed
                    ;
                    change = #True
                    apply = #False
                    ;
                  Case #g_wallpaper, #g_effect1_dots, #g_effect1_fade, #g_effect1_darken, #g_effect1_drain, #g_effect1_invert, #g_effect1_blur, #g_big_transparent, #g_big_reverse, #g_effect2_dots, #g_effect2_fade, #g_effect2_darken, #g_effect2_drain, #g_effect2_invert, #g_effect2_blur
                    ;
                    ; checkboxes can be immediately processed (part 1)
                    ;
                    change = #True
                    apply = #True
                    ;
                  Case #g_normal_transparent, #g_normal_reverse, #g_effect3_dots, #g_effect3_fade, #g_effect3_darken, #g_effect3_drain, #g_effect3_invert, #g_effect3_blur, #g_effect4_round, #g_keep, #g_resident, #g_pre10, #g_markup
                    ;
                    ; checkboxes can be immediately processed (part 2)
                    ;
                    change = #True
                    apply = #True
                    ;
                  Case #g_wallpaper_browse
                    ;
                    ; browse for a file or folder
                    ;
                    Select GetGadgetState(#g_wallpaper)
                        Case #g_wallpaper__frompath
                          file = PathRequester("Select folder","")
                          If file > ""
                            SetGadgetText(#g_wallpaper_file,file)
                            guitocommandline()
                            change = #True
                            apply = #True
                          EndIf
                        Default
                          file = OpenFileRequester("Select image","","Image (*.JPG *.PNG *.BMP)|*.jpg;*.png;*.bmp|All (*.*)|*.*",0)
                          If file > ""
                            SetGadgetText(#g_wallpaper_file,file)
                            guitocommandline()
                            change = #True
                            apply = #True
                          EndIf
                    EndSelect
                    ;
                  Case #g_desktopshortcut
                    ;
                    ; create a shortcut on the desktop
                    ;
                    Select GetGadgetState(#g_panel)
                        Case 0
                          t = GetGadgetText(#g_wallpapername)
                          If t = ""
                            t = FormatDate("%yy%mm%dd %hh%ii%ss",Date())
                            n = 0
                            While n < command_n
                              n = n+1
                              command = LCase(x_commandfield(commandline,n,#True))
                              parameter = LCase(x_commandfield(commandline,n+1,#True))
                              Select command
                                  Case "text"
                                    If Len(parameter) < 30
                                      t = t+" "+parameter
                                    Else
                                      t = t+" "+Left(parameter,27)+"..."
                                    EndIf
                                    n =n+1
                                  Case "load"
                                    t = t+" "+GetFilePart(parameter)
                                    n = n+1
                                  Case "random"
                                    If Right(parameter,1) = "\"
                                      parameter = x_chop(parameter,0,1)
                                    EndIf
                                    t = t+" random "+GetFilePart(parameter)
                                    n = n+1
                                  Case "red", "blue", "green", "yellow", "pink", "cyan", "lime", "orange", "black", "white", "grey", "traffic", "base", "mark", "renew", "keep", "resident", "background", "random", "markup"
                                    t = t+" "+command
                                  Case "distort", "expand"
                                    n = n+1
                              EndSelect
                            Wend
                          EndIf
                          t = "WallX "+t
                        Case 1
                          t = GetGadgetText(#g_shortcutname)
                          If t = ""
                            t = FormatDate("%yy%mm%dd %hh%ii%ss",Date())
                          EndIf
                        Default
                    EndSelect
                    t = ReplaceString(t,"~","")
                    t = ReplaceString(t,":","")
                    t = ReplaceString(t,"\","_")
                    t = ReplaceString(t,"/","_")
                    t = ReplaceString(t,"|"," ")
                    t = ReplaceString(t,"<","_")
                    t = ReplaceString(t,">","_")
                    t = ReplaceString(t,"*","_")
                    t = ReplaceString(t,"?","_")
                    t = ReplaceString(t,#DQUOTE$,"")
                    t = ReplaceString(t,"   "," ")
                    t = ReplaceString(t,"  "," ")
                    If Len(t) > 70
                      t = Left(t,67)+"..."
                    EndIf
                    Select GetGadgetState(#g_panel)
                        Case 0
                          If Len(commandline) > 0
                            target.s = ProgramFilename()
                            link.s = x_getspecialfolderlocation(#CSIDL_DESKTOPDIRECTORY)+Trim(t)+".lnk"
                            x_createshelllink(target,link,commandline,"",GetPathPart(target),target, 0)
                          EndIf
                        Case 1
                          target = Trim(GetGadgetText(#g_executable_name))
                          icon = Trim(GetGadgetText(#g_icon_name))
                          If icon = ""
                            If LCase(Right(target,4)) =".bat"
                              icon = GetPathPart(ProgramFilename())+"wallx_bat.ico"
                            ElseIf Left(target,8) = "https://" Or LCase(Right(target,4)) = ".url"
                              icon = GetPathPart(ProgramFilename())+"wallx_url.ico"
                            EndIf
                            If Not x_exist(icon)
                              icon = ""
                            EndIf
                          EndIf
                          If target > ""
                            link = x_getspecialfolderlocation(#CSIDL_DESKTOPDIRECTORY)+Trim(t)+".lnk"
                            x_createshelllink(target,link,GetGadgetText(#g_parameters),"",GetGadgetText(#g_path_name),icon,0)
                            apply = #True
                          EndIf
                        Default
                    EndSelect
                    ;
                  Case #g_autorun_clear
                    ;
                    ; remove the autorun entry
                    ;
                    x_registry_delete(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX")
                    readautorun()
                    updatethings(0)
                    ;
                  Case #g_autorun_set
                    ;
                    ; create an autorun entry
                    ;
                    t = Chr(34)+ProgramFilename()+Chr(34)+" "+commandline
                    x_registry_set(#HKEY_CURRENT_USER,"Software\Microsoft\Windows\CurrentVersion\Run","WallX",#REG_SZ,0,t,1)
                    readautorun()
                    updatethings(0)
                    ;
                  Case #g_copy
                    ;
                    ; copy to clipboard
                    ;
                    Select GetGadgetState(#g_panel)
                        Case 0
                          SetClipboardText("wallx "+commandline)
                        Case 1
                          SetClipboardText(GetGadgetText(#g_shortcutcommand))
                        Default
                    EndSelect
                    ;
                  Case #g_shortcut
                    ;
                    n = GetGadgetState(#g_shortcut)
                    showshortcutdata(n)
                    SelectElement(shortcut(),n)
                    If shortcut()\type = #shortcut_wallpaper
                      apply = #True
                    EndIf
                    ;
                  Case #g_executable_browse
                    ;
                    ; browse for a file or folder
                    ;
                    file = OpenFileRequester("Select executable","","Executable (*.EXE *.BAT *.LNK)|*.exe;*.bat;*.lnk|All (*.*)|*.*",0)
                    If file > ""
                      SetGadgetText(#g_executable_name,file)
                      updatethings(1)
                    EndIf
                    ;
                  Case #g_path_browse
                    ;
                    ; browse for a file or folder
                    ;
                    file = PathRequester("Select folder","")
                    If file > ""
                      SetGadgetText(#g_path_name,file)
                    EndIf
                    ;
                  Case #g_icon_browse, #g_icon_image
                    ;
                    ; browse for a file or folder
                    ;
                    file = OpenFileRequester("Select icon or image","","Icon (*.ICO *.EXE *.JPG *.BMP)|*.ico;*.exe;*.bmp;*.jpg|All (*.*)|*.*",0)
                    If file > ""
                      SetGadgetText(#g_icon_name,file)
                      updatethings(1)
                    EndIf
                    ;
                  Case #g_addshortcut
                    ;
                    ; add shortcut
                    ;
                    With shortcut()
                      LastElement(shortcut())
                      AddElement(shortcut())
                      Select GetGadgetState(#g_panel)
                          Case 0
                            ;
                            ; add a wallpaper
                            ;
                            \type = #shortcut_wallpaper
                            \name = GetGadgetText(#g_wallpapername)
                            \executable = ""
                            \parameters = commandline
                            \path = ""
                            \icon = ""
                            ;
                          Case 1
                            ;
                            ; add a shortcut
                            ;
                            \name = GetGadgetText(#g_shortcutname)
                            If \name = ""
                              \type = #shortcut_separator
                              \name = "------"
                              \executable = ""
                              \parameters = ""
                              \parameters = ""
                              \icon = ""
                            Else
                              \type = #shortcut_shortcut
                              \executable = GetGadgetText(#g_executable_name)
                              \parameters = GetGadgetText(#g_parameters)
                              \path = GetGadgetText(#g_path_name)
                              \icon = GetGadgetText(#g_icon_name)
                            EndIf
                            ;
                          Default
                      EndSelect
                      AddGadgetItem(#g_shortcut,-1,\name)
                      showshortcutdata(ListSize(shortcut())-1)
                    EndWith
                    updatethings(-1)
                    saveconfig()
                    buildshortcutpanel()
                    ;
                  Case #g_replaceshortcut
                    ;
                    With shortcut()
                      SelectElement(shortcut(),GetGadgetState(#g_shortcut))
                      Select GetGadgetState(#g_panel)
                          Case 0
                            ;
                            ; add a wallpaper
                            ;
                            \type = #shortcut_wallpaper
                            \name = GetGadgetText(#g_wallpapername)
                            \executable = ""
                            \parameters = commandline
                            \path = ""
                            \icon = ""
                            ;
                          Case 1
                            ;
                            ; add a shortcut
                            ;
                            \name = GetGadgetText(#g_shortcutname)
                            If \name = ""
                              \type = #shortcut_separator
                              \name = "------"
                              \executable = ""
                              \parameters = ""
                              \parameters = ""
                              \icon = ""
                            Else
                              \type = #shortcut_shortcut
                              \executable = GetGadgetText(#g_executable_name)
                              \parameters = GetGadgetText(#g_parameters)
                              \path = GetGadgetText(#g_path_name)
                              \icon = GetGadgetText(#g_icon_name)
                            EndIf
                            ;
                          Default
                      EndSelect
                    EndWith
                    updatethings(-1)
                    saveconfig()
                    buildshortcutpanel()
                    ;
                  Case #g_removeshortcut
                    ;
                    ; remove shortcut
                    ;
                    With shortcut()
                      n = GetGadgetState(#g_shortcut)
                      If n > 1
                        SelectElement(shortcut(),n)
                        DeleteElement(shortcut())
                        RemoveGadgetItem(#g_shortcut,n)
                        If n >= ListSize(shortcut())
                          n = n-1
                        EndIf
                        SetGadgetState(#g_shortcut,n)
                        SelectElement(shortcut(),n)
                        Select shortcut()\type
                            Case #shortcut_wallpaper
                              If n = #default_shortcut_autorun
                                readautorun()
                              EndIf
                              SetGadgetText(#g_wallpapername,\name)
                              SetGadgetText(#g_commandline,\parameters)
                              commandline = \parameters
                              commandlinetogui()
                              updatethings(0)
                              apply = #True
                            Case #shortcut_separator, #shortcut_shortcut
                              SetGadgetText(#g_shortcutname,\name)
                              SetGadgetText(#g_executable_name,\executable)
                              SetGadgetText(#g_parameters,\parameters)
                              SetGadgetText(#g_path_name,\path)
                              SetGadgetText(#g_icon_name,\icon)
                              updatethings(1)
                            Default
                        EndSelect
                      EndIf
                    EndWith
                    saveconfig()
                    buildshortcutpanel()
                    ;
                  Case #g_editshortcuts
                    ;
                    ; edit shortcuts file
                    ;
                    saveconfig()
                    If x_existx(configfile)
                      configsize = FileSize(configfile)
                      configdate = GetFileDate(configfile,#PB_Date_Modified)
                      configtimer = GetTickCount_()+1000
                      RunProgram("notepad.exe",configfile,"")
                    EndIf
                    ;
                  Case #g_refresh
                    ;
                    Select GetGadgetState(#g_panel)
                        Case 0
                          updatethings(0)
                          apply = #True
                        Case 1
                          updatethings(1)
                        Default
                    EndSelect
                    ;
                  Case #g_exporticonimage
                    ;
                    ; save (icon)image
                    ;
                    updatethings(1)
                    exporticonimage()
                    ;
                  Case #g_exportpath_browse
                    ;
                    ; browse for a file or folder
                    ;
                    file = PathRequester("Select folder",exportpath)
                    If file > ""
                      exportpath = file
                      SetGadgetText(#g_exportpath_name,exportpath)
                    EndIf
                    ;
                  Case #g_help
                    ;
                    ; show help text
                    ;
                    help = GetPathPart(ProgramFilename())+"wallx.txt"
                    If x_exist(help)
                      RunProgram("notepad",help,"")
                    Else
                      HideWindow(#w_main_nr,1)
                      x_littlehelp(" WallX "+#program_version+" - "+#program_copyright+" - "+FormatDate("%DD.%MM.%YYYY",#codecaddy_build_date)+" build "+Str(#codecaddy_build_nr)+" save "+Str(#codecaddy_save_nr),"",p_helptext,#PB_Ascii)
                      HideWindow(#w_main_nr,0)
                    EndIf
                    ;
                  Case #g_runprogram
                    ;
                    file = GetGadgetText(#g_executable_name)
                    file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
                    parameters = GetGadgetText(#g_parameters)
                    parameters = ReplaceString(parameters,"~programfolder~",GetPathPart(ProgramFilename()))
                    working = GetGadgetText(#g_path_name)
                    working = ReplaceString(working,"~programfolder~",GetPathPart(ProgramFilename()))
                    If working = ""
                      working = GetPathPart(file)
                    EndIf
                    If (LCase(GetGadgetText(#g_shortcutname)) = "wallx" And file = "") Or file = "wallx.exe"
                      If parameters = ""
                      Else
                        commandline = parameters
                        executecommands()
                      EndIf
                    Else
                      RunProgram(file,parameters,working)
                    EndIf
                    ;
                  Case #g_editbatch
                    ;
                    file = GetGadgetText(#g_executable_name)
                    file = ReplaceString(file,"~programfolder~",GetPathPart(ProgramFilename()))
                    RunProgram("notepad.exe",file,GetPathPart(file))
                    ;
                  Case #g_exit
                    ;
                    ; well... just go now and sin more creatively next time!
                    ;
                    exit = #True
                    ;
                  Case #g_shortcutpanel
                    ;
                    With shortcut()
                      x = GetGadgetAttribute(#g_shortcutpanel,#PB_Canvas_MouseX)
                      y = GetGadgetAttribute(#g_shortcutpanel,#PB_Canvas_MouseY)
                      Select event_type
                          Case #PB_EventType_MouseMove
                            ResetList(shortcut())
                            n = 0
                            If rearrange <> 3
                              hitbox = -1
                              While NextElement(shortcut()) And hitbox = -1
                                If x >= \x And x < \x+\w And y >= \y And y < \y+\h
                                  hitbox = n
                                EndIf
                                n = n+1
                              Wend
                            Else
                              While NextElement(shortcut())
                                If x >= \x And x < \x+\w And y >= \y+\h/4 And y < \y+\h-\h/4
                                  hitbox = n
                                EndIf
                                n = n+1
                              Wend
                            EndIf
                          Case #PB_EventType_MouseLeave
                            hitbox = -1
                            rearrange = 0
                          Case #PB_EventType_MouseEnter
                            hitbox_old = -1
                          Case 65543                                                            ; right mouse button up
                            showshortcutdata(hitbox)
                            HideWindow(#w_shortcutpanel_nr,1)
                            HideWindow(#w_main_nr,0)
                            SetActiveWindow(#w_main_nr)
                            gui = #True
                          Case 65540                                                            ; mouse button down
                            rearrange = 1
                          Case 65541                                                            ; mouse button up
                            ;
                            ; rearrange = 0 - button's up, mouse is moving over the options
                            ;             1 - button down, pick or grab
                            ;             2 - button was down and is up again on the same hitbox -> pick
                            ;             3 - button was down but changed hitbox -> rearranging
                            ;
                            If hitbox > -1
                              If rearrange = 1
                                rearrange = 2
                              ElseIf rearrange = 3
                                saveconfig()
                                loadconfig()
                                buildshortcutpanel()
                                rearrange = 0
                              EndIf
                            EndIf
                          Default
                      EndSelect
                      ;
                      If hitbox <> hitbox_old                                                  ; pointer changed hitbox
                        If rearrange = 1 Or rearrange = 3
                          If hitbox > -1 And hitbox_old > -1
                            rearrange = 3                                                      ; we're rearranging
                            ;
                            While hitbox_old < hitbox
                              SelectElement(shortcut(),hitbox_old)
                              sc_old = @shortcut()
                              SelectElement(shortcut(),hitbox_old+1)
                              sc_new = @shortcut()
                              SwapElements(shortcut(),sc_old,sc_new)
                              hitbox_old = hitbox_old+1
                            Wend
                            While hitbox_old > hitbox
                              SelectElement(shortcut(),hitbox_old)
                              sc_old = @shortcut()
                              SelectElement(shortcut(),hitbox_old-1)
                              sc_new = @shortcut()
                              SwapElements(shortcut(),sc_old,sc_new)
                              hitbox_old = hitbox_old-1
                            Wend
                            ;
                            buildshortcutpanel()
                          EndIf
                        EndIf
                        If hitbox_old > -1
                          StartDrawing(CanvasOutput(#g_shortcutpanel))
                            SelectElement(shortcut(),hitbox_old)
                            DrawImage(ImageID(\image_low),\x,\y)
                          StopDrawing()
                        EndIf
                        If hitbox > -1
                          ;
                          ; real time update, need a settings tab some day
                          ;
                          ; showshortcutdata(hitbox)
                          ;
                          SelectElement(shortcut(),hitbox)
                          StartDrawing(CanvasOutput(#g_shortcutpanel))
                            If \type = #shortcut_shortcut Or \type = #shortcut_wallpaper
                              DrawImage(ImageID(\image_high),\x,\y)
                            EndIf
                          StopDrawing()
                        EndIf
                        hitbox_old = hitbox
                      EndIf
                      If rearrange = 2 And hitbox > -1                                        ; up on the same hitbox -> launch or execute
                        SelectElement(shortcut(),hitbox)
                        Select \type
                            Case #shortcut_shortcut
                              If LCase(\name) = "wallx" And \executable = ""
                                HideWindow(#w_shortcutpanel_nr,1)
                                HideWindow(#w_main_nr,0)
                                SetActiveWindow(#w_main_nr)
                                ; ShowWindow_(w_main_h,#SW_RESTORE)
                                ; PostMessage_(#HWND_BROADCAST,#WM_SYSCOMMAND,#SC_HOTKEY,w_main_h)
                                gui = #True
                              Else
                                showshortcutdata(hitbox)
                                file = ReplaceString(\executable,"~programfolder~",GetPathPart(ProgramFilename()))
                                parameters = ReplaceString(\parameters,"~programfolder~",GetPathPart(ProgramFilename()))
                                working = ReplaceString(\path,"~programfolder~",GetPathPart(ProgramFilename()))
                                If working = ""
                                  working = GetPathPart(file)
                                EndIf
                                RunProgram(file,parameters,working)
                              EndIf
                            Case #shortcut_wallpaper
                              If \parameters > ""
                                commandline = \parameters
                                executecommands()
                              EndIf
                              showshortcutdata(hitbox)
                            Default
                        EndSelect
                        rearrange = 0
                      EndIf
                    EndWith
              EndSelect
        EndSelect
      Else
        ;
        ; no events, so anything else that changed and triggers a redraw?
        ;
        ; check for desktop changes
        ;
        apply = apply | checkdesktops()
        ;
        ; detect hibernations or other long (20 seconds+) freezes
        ;
        If freeze_counter <> 0 And (GetTickCount_() - freeze_counter) > (20*1000)
          apply = #True
        EndIf
        freeze_counter = GetTickCount_()
        ;
        ; check for ip changes
        ;
        If checkipadresses() = #True
          apply = #True
        EndIf
        ;
        ; check for wallpaper changes (user or other app changed wallpaper)
        ;
        wall_current = Space(255)
        SystemParametersInfo_(#SPI_GETDESKWALLPAPER,255,@wall_current,0)
        If OSVersion() >= #PB_OS_Windows_XP And wall_filename <> wall_current
          apply = #True
        EndIf
        ;
        ; check for periodic renewals when user is not active
        ;
        If renew_counter = 0
          renew_counter = GetTickCount_()
        EndIf
        If renew > 0
          If (GetTickCount_()-renew_counter) > (renew*1000) Or (GetTickCount_()-renew_counter) < 0
            GetLastInputInfo_(@lastinputinfo)
            If (GetTickCount_()-lastinputinfo\dwTime) > (nouser*1000) Or (GetTickCount_()-lastinputinfo\dwTime) < 0 Or nouser = 0
              apply = #True
            EndIf
          EndIf
        EndIf
        ;
        ; monitor for changed presets file
        ;
        If configtimer > 0 And configtimer < GetTickCount_()
          If x_exist(configfile)
            If FileSize(configfile) <> configsize Or GetFileDate(configfile,#PB_Date_Modified) <> configdate
              loadconfig()
              updatethings(-1)
              buildshortcutpanel()
              configsize = FileSize(configfile)
              configdate = GetFileDate(configfile,#PB_Date_Modified)
            EndIf
            configtimer = GetTickCount_()+1000
          Else
            configtimer = 0
          EndIf
        EndIf
        ;
        ; executecommands if any changes
        ;
        If apply
          If change
            guitocommandline()
            apply = #False
            change = #False
          Else
            apply = #False
          EndIf
          SetGadgetState(#g_busy_led,ImageID(#i_led_red))
          executecommands()
          SetGadgetState(#g_busy_led,ImageID(#i_led_white))
          renew_counter = GetTickCount_()
        EndIf
        ;
        ; when to terminate the program
        ;   1. kill message (look for kill_countdown)
        ;   2. not-gui + error
        ;   3. not-gui + closewindow
        ;   4. not-gui + kill message
        ;   5. gui + exit
        ;   6. gui + not-resident + closewindow
        ;   7. no gui + not resident
        ;
        ; when to send it to systray (hide)
        ;   1. gui + resident + closewindow
        ;
        If gui = #False
          If command_error = #True
            exit = #True
          ElseIf event = #PB_Event_CloseWindow
            exit = #True
          ElseIf stayresident = #False
            exit = #True
          EndIf
        EndIf
      EndIf
      ;
    Until exit = #True
    ;
    CloseWindow(#w_main_nr)
    ;
  EndIf
  ;
  CloseLibrary(1)
EndProcedure

; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; CursorPosition = 2900
; FirstLine = 1741
; Folding = DgBgH+
; Markers = 3504,4723
; EnableThread
; EnableXP
; UseIcon = icons\walnut.ico
; Executable = wallx.exe
; CurrentDirectory = C:\software\purebasic\_projects\
; CompileSourceDirectory
; EnableCompileCount = 6483
; EnableBuildCount = 326
; EnableExeConstant
; EnableUnicode